#!/bin/bash

set +xv

if [ -d /sys/fs/elmacfs ]; then
	ELMACFS="/sys/fs/elmacfs"
else
	ELMACFS="/elmac"
fi

SYSWRITEUP_FILE=${ELMACFS}/mac_write_up

test_elmac_enable=`zcat /proc/config.gz | grep _ELMAC=y`
ret=$?
if [[ $ret != 0 ]]; then
	echo "The kernel does not support ELMAC"
	exit 1
fi

test_elmac_enable=`cat ${SYSWRITEUP_FILE}`
ret=$?
if [[ $ret != 0 ]]; then
	echo "ELMAC is not activated or does not function correctly"
	exit 1
fi

echo "ELMAC enable"

exit 0
