#include <sys/time.h>
#include <time.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/wait.h>
#include <pwd.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <signal.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <setjmp.h>
#include <string.h>

#include <linux/mac/mac_types.h>
#include <linux/mac/mac.h>
#include <linux/mac/mac_user.h>
#include <linux/mac/macfun.h>

int main(int argc, char *argv[])
{
	unsigned int	pid;
	unsigned int	ret;
	unsigned int	test_uid;
	unsigned int	test_inode;
	int		status;
	int		fd;

	if (argc != 4) {
		printf("USAGE: %s <test_uid> <test_inode> <name file test_inode>\n", argv[0]);
		return 1;
	}
	printf("%d:: %d uid\n", getpid(), getuid());
	printf("%d:: %d euid\n", getpid(), geteuid());
	test_uid = atoi(argv[1]);
	printf("%d:: %d test_uid\n", getpid(), test_uid);
	test_inode = atoi(argv[2]);
	printf("%d:: %d 0x%08x test_inode\n", getpid(), test_inode, test_inode);
	ret = mac_set_test_inode(test_inode);
	if (ret < 0) {
		printf("%d:: ERR mac_set_test_inode(%d): %d %s\n", getpid(), test_inode, ret, strerror(errno));
		return 2;
	}
	fd = open(argv[3], O_RDONLY);
	if (fd < 0) {
		printf("%d:: ERR open(%s): %s\n", getpid(), argv[3], strerror(errno));
		return 3;
	}
	close(fd);
	pid = fork();
	switch (pid) {
	case 0:
		ret = setuid(test_uid);
		if (ret < 0) {
			printf("%d:: ERR setuid(%d): %s\n", getpid(), test_uid, strerror(errno));
			exit(1);
		}
		printf("%d:: %d uid\n", getpid(), getuid());
		printf("%d:: %d euid\n", getpid(), geteuid());
		test_uid = atoi(argv[1]);
		printf("%d:: %d test_uid\n", getpid(), test_uid);
		fd = open(argv[3], O_RDONLY);
		if (fd < 0) {
			printf("%d:: ERR open(%s): %s\n", getpid(), argv[3], strerror(errno));
			return 3;
		}
		close(fd);
		break;
	case -1:
		printf("%d:: ERR fork(): %s\n", getpid(), strerror(errno));
		exit(1);
	default:
		pid = wait(&status);
		printf("%d:: waited child %i status: 0x%08x\n", getpid(), pid, status);
	}
	return 0;
}
