#include <sys/time.h>
#include <time.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/wait.h>
#include <pwd.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <signal.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <setjmp.h>
#include <string.h>

#if defined (BSD) && !_POSIX_SOURSE
	#include <sys/dir.h>
	typedef struct direct Dirent;
#else
	#include <dirent.h>
	typedef struct dirent Dirent;
#endif


#define CPEC_PORT 2500
#define	MSGMAX	1024
#define	STRSIZE	1024
#define	SHMSIZE	128
#define	l_check	8

//hrtime_t	;

struct	stat	buf_stat;
static	jmp_buf	env;

char	*DIRECTORY_TMAC = "";
char	*FILE_CONF_TMAC = "tmac.cnf";
char	*FILE_TMAC_EXE = "tmac";
char	*HOSTNAME = "/etc/HOSTNAME";

char	HOST_LOCK[STRSIZE];
char	HOST[STRSIZE];
char	path_file_serv[STRSIZE];
char	DIR_TMAC[STRSIZE];
char	CONF_FILE[STRSIZE];
char	TMAC_EXE[STRSIZE];
char	path_dir_serv[STRSIZE];
char	*mmap_CONF_FILE;
char	*p_ROOT_E90;
char	*p_name_user_max;
char	*p_banner;
char	*s_rez_d;
char	*s_rez_empty;
char	*s_ret_empty_s;
char	*s_ret_d;
char	*s_ret_s;
char	*s_ret_empty;
char	*s_banner;

int	p_print_o = 0;
int	p_print_c = 0;
int	p_print_cnf = 0;
int	p_print_d;
int	p_print_f;
int	p_print_m;
int	p_print_s;
int	p_print_S;
int	p_print_Sh;
int	p_print_send;
int	p_print_recv;
int	p_print_sig;
int	p_print_shm;
int	p_print_p;
int	p_print_pid;
int	p_print_usag;
int	p_print_kill;
int	p_print_long;
int	p_print_SPEC;
int	p_print_work;

int	pid_parent;
int	pid_server_cpecial;
int	pid_rcp_rsh;
int	i_am_main;
int	count_sigs = 0;
int	count_users = 0;
int	count_file = 0;
int	i_am_check = 0;
int	l1;
int	f1;
int	macdef = 1;
int	l_name_user_max;
int	l_name_user_all;
int	l_name_user;
int	l_sdvig;
int	i;
int	ret;
int	numel = 1;

uid_t	uid_old;
gid_t	gid_old;
uid_t	euid_old;
gid_t	egid_old;

char	*p_comment =
	"\n"
	"Пояснения к реализовавшейся матрице доступа:\n"
	"\n"
	"d - directory\n"
	"- - file\n"
	"m - message\n"
	"\tgcsrs: - msgget(), msgctl(IPC_STAT), "
	"msgctl(IPC_SET), msgrcv(), msgsnd()\n"
	"r - shmat\n"
	"\tgcsad: - shmget(), shmctl(IPC_STAT), shmctl(IPC_SET), "
	"shmat(), shmdt()\n"
//	"s - semaphor\n"
//	"\tgcs+mn: - semget(), semctl(IPC_STAT), semctl(IPC_SET), "
//	"semop(+1), semop(-1), semop(==0)\n"
//	"L - socket на локальной машине для использования в качестве клиента\n"
//	"\tscsrb: - socket(), connect(), send(), recv(), bind()\n"
//	"H - socket на удаленной машине для использования в качестве клиента\n"
//	"\tscsr: - socket(), connect(), send(), recv()\n"
//	"l - socket на локальной машине для использования в качестве сервера\n"
//	"\tsbla: - socket(), bind(), listen(), accept()\n"
//	"h - socket на удаленной машине для использования в качестве сервера\n"
//	"\tsbla: - socket(), bind(), listen(), accept()\n"
//	"\n"
	"Причины отказа в доступе:\n"
//	"\t u: - Порт занят другим процессом.\n"
	"\t p: - Нет прав для доступа к объекту.\n"
	"\t o: - Субъект - не владелец объекта.\n"
	"\t #: - Объект не существует.\n"
	"\t -: - Проверка не произведена.\n"
	"\t ?: - Другие.\n";

key_t	i_msg;
int	p_msg;
key_t	i_sem;
int	p_sem;

struct	msqbuf
{
	long	mtype;
	char	mtext[MSGMAX];
};
//struct	msqbuf	msg_snd = {15, "m"};
//struct	msqbuf	msg_rcv = {15, "m"};
struct	msqbuf	msg_snd = {1, "m"};
struct	msqbuf	msg_rcv = {0, "m"};


/*
 *	Элемент списка атрибутов пользователя
 */
	
typedef struct passwd_users passwd_users_t;

passwd_users_t	**p_users_cnf;

struct passwd_users {
	char	*pw_name;
	int	l_name;
	uid_t	pw_uid;
	gid_t	pw_gid;
	char	*pw_dir;
	int	pid_server;
	int	pid_server_h;
	int	nport;
	int	nport2;
	passwd_users_t 	*next;
};
	
passwd_users_t	*init_user();
passwd_users_t	*obtain_user(char *);
passwd_users_t	**get_users_cnf();
int	creat_obj(passwd_users_t **);
int	check_access(passwd_users_t **, passwd_users_t *);
int	check_access_users(passwd_users_t **);
void	if_printf(int, const char *, ...);
void	access_ret(char *, char *);
int	creat_msg(passwd_users_t *);
int	send_msg(passwd_users_t **p_users_cnf);
int	check_msg(passwd_users_t **, char *);
int	delete_msg(passwd_users_t **);
int	creat_df(char *, char *, int, int, char, int);

//int	creat_sem(passwd_users_t *);
//int	check_sem(passwd_users_t **, char *);
//int	delete_sem(passwd_users_t **);
int	creat_shm(passwd_users_t *);
int	check_shm(passwd_users_t **, char *);
int	delete_shm(passwd_users_t **);
int	creat_server(passwd_users_t **p_users_cnf);
int	server_socket_tcp(passwd_users_t *, char *);
int	client_socket_tcp(char *);
int	check_socket(passwd_users_t **, passwd_users_t *, char *, int);
void	fun_sig_ign(int);
char 	*obtainlex(char *);
int	arrow_digit(char *);
int	get_nport(char *);
int	srv_sock_tcp_h(char *, int);
int	inic_host();
void	delete_obj(passwd_users_t **);
int	server_cpecial();




int delta_usec(struct timeval *tv1, struct timeval *tv2, struct timeval *tv3)
{
	if (tv1 == (struct timeval *)NULL) {
		fprintf(stderr, "delta_usec:: ERR: tv1 is NULL\n");
		exit(1);
	}
	if (tv2 == (struct timeval *)NULL) {
		fprintf(stderr, "delta_usec:: ERR: tv2 is NULL\n");
		exit(1);
	}
	if (tv3 == (struct timeval *)NULL) {
		fprintf(stderr, "delta_usec:: ERR: tv3 is NULL\n");
		exit(1);
	}
	tv3->tv_sec = tv2->tv_sec - tv1->tv_sec;
	if (tv3->tv_sec == 0) {
		if (tv2->tv_usec < tv1->tv_usec) {
			fprintf(stderr, "delta_usec:: ERR\n"
					"tv3->tv_sec == 0, but tv2->tv_usec < tv1->tv_usec\n");
			exit(1);
		}
		tv3->tv_usec = tv2->tv_usec - tv1->tv_usec;
	} else {
		tv3->tv_sec -= 1;
		tv3->tv_usec = 10000000 - tv1->tv_usec + tv2->tv_usec;
	}
	if (tv3->tv_usec > 1000000) {
		tv3->tv_sec += 1;
		tv3->tv_usec -= 1000000;
	}
	return 0;
}

/*
 *	get_users_cnf возвращает указатель на массив, содержащий имена
 *	 проверяемых пользователей. 
 */
 
passwd_users_t **get_users_cnf(void) {
	FILE	*F1;
	FILE	*F2;
	int	ddd;

	char	s[STRSIZE];
	char	*p_s;
	char	*p_1;
	char	*p_2;
	char	*p_3;
	int	count = 0;
	int	l_1;
	int	nhost = 0;


	passwd_users_t	*pwd_users = (passwd_users_t *)NULL;
	passwd_users_t	**pwd_current = (passwd_users_t **)NULL;


	if ((p_ROOT_E90 = getenv("ROOT_E90")) == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:: set environment "
			"ROOT_E90 and try again\n", getpid());
		if (i_am_main == 0) {
			(void) fprintf(stderr,
				"%i TMAC fail:: i_am_main == 0: "
				"send to main mashin ????\n", getpid());
		}
		exit(1);
	}
	strcpy(DIR_TMAC, p_ROOT_E90);
	strcat(DIR_TMAC, DIRECTORY_TMAC);
	strcpy(CONF_FILE, DIR_TMAC);
	strcat(CONF_FILE, "/");
	strcat(CONF_FILE, FILE_CONF_TMAC);
	if ((F1 = fopen(CONF_FILE, "r")) == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:: could't fopen %s %s\n",
			getpid(), CONF_FILE, strerror(errno));
		return ((passwd_users_t **)0);
	}
	if ((F2 = fopen(HOSTNAME, "r")) == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:: could't fopen %s %s\n",
			getpid(), HOSTNAME, strerror(errno));
		return ((passwd_users_t **)0);
	}
	p_s = s;
	if (fgets(p_s, STRSIZE, F2) == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:: could't fgets %s %s\n",
			getpid(), HOSTNAME, strerror(errno));
		return ((passwd_users_t **)0);
	}
	fclose(F2);
	if ((p_s = obtainlex(s)) == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:: "
			"could't found host in %s\n",
			getpid(), HOSTNAME);
		return ((passwd_users_t **)0);
	}
	strcpy(HOST_LOCK, p_s);
	if_printf(p_print_cnf, "HOST_LOCK: %s\n", HOST_LOCK);
	p_print_d = 0;
	p_print_f = 0;
	p_print_m = 0;
	p_print_s = 0;
	p_print_S = 0;
	p_print_Sh = 0;
	p_print_send = 0;
	p_print_recv = 0;
	p_print_sig = 0;
	p_print_shm = 0;
	p_print_p = 0;
	p_print_usag = 0;
	p_print_pid = 0;
	p_print_kill = 0;
	p_print_long = 0;
	p_print_SPEC = 0;
	p_print_work = 0;
	
	p_s = s;
	HOST[0] = 0;
	while (fgets(p_s, STRSIZE, F1)) {
		p_s = s;
		count++;
		p_1 = NULL;
		p_2 = NULL;
		if ((p_1 = (char *)strchr(p_s, '#')) != NULL)
			*p_1 = 0;
		if ((l_1 = strlen(p_s)) == 0)
			continue;
		if ((p_1 = (char *)strstr(p_s, "HOST")) != NULL) {
			if ((p_3 = (char *)strchr(p_s, ':')) != NULL) {
				if ((p_2 = obtainlex(p_3 + 1)) == NULL) {
					(void) fprintf(stderr,
						"%i TMAC fail:: bad tmac.cnf: "
						"could't found host; p. %i\n",
						getpid(), count);
					return ((passwd_users_t **)0);
				}
				if_printf(p_print_cnf, "%s\n", p_2);
				if ((l_1 = strlen(p_2)) == 0) {
					(void) fprintf(stderr,
						"%i TMAC fail:: bad tmac.cnf: "
						"strlen(host) == 0; p. %i\n",
						getpid(), count);
					return ((passwd_users_t **)0);
				}
				if (l_1 > STRSIZE) {
					(void) fprintf(stderr,
						"%i TMAC fail:: bad tmac.cnf: "
						"strlen(host) > STRSIZE; p. %i\n",
						 getpid(), count);
					return ((passwd_users_t **)0);
				}
				if (++nhost > 2) {
					(void) fprintf(stderr,
						"%i TMAC fail:: bad tmac.cnf: "
						"nhost > 2; p. %i\n",
						 getpid(), count);
					return ((passwd_users_t **)0);
				}
			
				if (strncmp(HOST_LOCK, p_2, l_1) == 0) {
					i_am_check = 1;
					if_printf(p_print_cnf,
						"i_am_check: %i\n", i_am_check);
				} else {
					strcpy(HOST, p_2);
					if_printf(p_print_cnf,
						"HOST: %s\n", HOST);
				}
				continue;
			} else {
				(void) fprintf(stderr,
					"%i TMAC fail:: bad tmac.cnf: "
					"could't found : after HOST; p. %i\n",
					getpid(), count);
					return ((passwd_users_t **)0);
			}
		}
		if (((p_1 = (char *)strchr(p_s, ':')) != NULL) && ((p_3 = (char *)strchr(p_1 + 1, ':')) != NULL)) {
			if ((p_2 = obtainlex(p_s)) == NULL) {
				(void) fprintf(stderr,
					"%i TMAC fail:: bad tmac.cnf: "
					"could't found user; p. %i\n",
					getpid(), count);
				return ((passwd_users_t **)0);
			}
			if_printf(p_print_cnf, "%s\n", p_2);
/**/
			if ((pwd_users = (passwd_users_t *)obtain_user(p_2))
				== (passwd_users_t *)0) {
				(void) fprintf(stderr,
					"%i TMAC fail:: "
					"obtain_user(%s) == NULL\n",
					getpid(), p_2);
				return ((passwd_users_t **)0);
			}

			numel++;
		
			if_printf(p_print_o,
				"&pwd_users (0x%p) pwd_users (0x%p) "
				"*pwd_users (0x%p)\n",
				&pwd_users, pwd_users, *pwd_users);

			l_name_user = pwd_users->l_name;
			l_name_user_all += l_name_user + 1 > l_check ?
				   	   l_name_user + 1 : l_check;
			if (l_name_user > l_name_user_max) {
				l_name_user_max = l_name_user;
				p_name_user_max = p_2;
			}

			if (pwd_current == (passwd_users_t **)NULL) {
		
				if_printf(p_print_o,
					"malloc(sizeof "
					"(passwd_users_t *) * %i)\n",
					numel);

				if ((pwd_current =
					(passwd_users_t **)
					malloc(sizeof (passwd_users_t *) *
					numel))
					== 0) {
					(void) fprintf(stderr,
						"%i TMAC fail:: could't malloc "
						"for pwd_current: %s\n",
						getpid(), strerror(errno));
					return ((passwd_users_t **)0);
				}
			
				if_printf(p_print_o,
					"&pwd_current (0x%p) "
					"pwd_current (0x%p) "
					"*pwd_current (0x%p)\n",
					&pwd_current,
					pwd_current,
					*pwd_current);

				pwd_current[0] = pwd_users;
				pwd_current[1] = (passwd_users_t *)0;
			} else {
		
				if_printf(p_print_o,
					"realloc(sizeof "
					"(passwd_users_t *) * %i)\n",
					numel);

				if ((pwd_current =
					(passwd_users_t **)
					realloc(pwd_current,
					sizeof (passwd_users_t *) * numel))
					== 0) {
					(void) fprintf(stderr,
						"%i TMAC fail:: "
						"could't realloc "
						"for pwd_current: %s\n",
						getpid(), strerror(errno));
					exit(1);
				}
			
				if_printf(p_print_o,
					"&pwd_current (0x%p) "
					"pwd_current (0x%p) "
					"*pwd_current (0x%p)\n",
					&pwd_current,
					pwd_current,
					*pwd_current);

				pwd_current[numel - 2] = pwd_users;
				pwd_current[numel - 1] = (passwd_users_t *)0;
			}

/**/
			pwd_users->nport = get_nport(p_1 + 1);
			pwd_users->nport2 = get_nport(p_3 + 1);
			if_printf(p_print_cnf,
				"nport  %s %i\n"
				"nport2 %s %i\n",
				p_2, pwd_users->nport,
				p_3, pwd_users->nport2);
			continue;
		} else {
//			(void) fprintf(stderr,
//				"%i TMAC fail:: bad tmac.cnf: "
//				"could't found : for nport2 p. %i\n%s",
//				getpid(), count, p_s);
//			return ((passwd_users_t **)0);
		}
		if ((p_1 = obtainlex(p_s)) == NULL)
			continue;
		if_printf(p_print_cnf, "%s\n", p_1);
		if (strncmp(p_1, "directory", 9) == 0)
			p_print_d = 1;
		else
		if (strncmp(p_1, "file", 4) == 0)
			p_print_f = 1;
		else
		if (strncmp(p_1, "message", 7) == 0)
			p_print_m = 1;
		else
		if (strncmp(p_1, "semaphor", 8) == 0)
			p_print_s = 1;
		else
		if (strncmp(p_1, "socket", 6) == 0)
			p_print_S = 1;
		else
		if (strncmp(p_1, "sigset", 6) == 0)
			p_print_sig = 1;
		else
		if (strncmp(p_1, "process", 7) == 0)
			p_print_p = 1;
		else
		if (strncmp(p_1, "client_send", 11) == 0)
			p_print_send = 1;
		else
		if (strncmp(p_1, "shmat", 5) == 0)
			p_print_shm = 1;
		else
		if (strncmp(p_1, "sock_host", 9) == 0)
			p_print_Sh = 1;
		else
		if (strncmp(p_1, "client_recv", 11) == 0)
			p_print_recv = 1;
		else
		if (strncmp(p_1, "usag", 4) == 0)
			p_print_usag = 1;
		else
		if (strncmp(p_1, "pid_server", 10) == 0)
			p_print_pid = 1;
		else
		if (strncmp(p_1, "long", 4) == 0)
			p_print_long = 1;
		else
		if (strncmp(p_1, "SPEC", 4) == 0)
			p_print_SPEC = 1;
		else
		if (strncmp(p_1, "WORK", 4) == 0)
			p_print_work = 1;
		else
		if (strncmp(p_1, "kill", 4) == 0)
			p_print_kill = 1;
		else {
			(void) fprintf(stderr,
				"%i TMAC fail:: bad tmac.cnf: "
				"unknow lex; p. %i\n%s",
				getpid(), count, p_1);
			return ((passwd_users_t **)0);
		}
		continue;
	}
	if_printf(p_print_cnf, "p_print_d    %i\n", p_print_d);
	if_printf(p_print_cnf, "p_print_f    %i\n", p_print_f);
	if_printf(p_print_cnf, "p_print_m    %i\n", p_print_m);
	if_printf(p_print_cnf, "p_print_s    %i\n", p_print_s);
	if_printf(p_print_cnf, "p_print_S    %i\n", p_print_S);
	if_printf(p_print_cnf, "p_print_Sh   %i\n", p_print_Sh);
	if_printf(p_print_cnf, "p_print_send %i\n", p_print_send);
	if_printf(p_print_cnf, "p_print_recv %i\n", p_print_recv);
	if_printf(p_print_cnf, "p_print_sig  %i\n", p_print_sig);
	if_printf(p_print_cnf, "p_print_p    %i\n", p_print_p);
	if_printf(p_print_cnf, "p_print_usag %i\n", p_print_usag);
	if_printf(p_print_cnf, "p_print_pid  %i\n", p_print_pid);
	if_printf(p_print_cnf, "p_print_kill %i\n", p_print_kill);
	if_printf(p_print_cnf, "p_print_long %i\n", p_print_long);
	if_printf(p_print_cnf, "p_print_SPEC %i\n", p_print_SPEC);
	if_printf(p_print_cnf, "p_print_work %i\n", p_print_work);
	
	fclose(F1);
	if (numel == 1) {
		(void) fprintf(stderr,
			"%i TMAC fail:: bad tmac.cnf: not users!\n", getpid());
		return ((passwd_users_t **)0);
	}
	if (i_am_check == 0) {
		(void) fprintf(stderr,
			"%i TMAC fail:: bad tmac.cnf: "
			"I am not check\n", getpid());
		return ((passwd_users_t **)0);
	}

	l_name_user_all += l_check;
	if ((s_ret_d = (char *)malloc(l_name_user_all)) == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:: could't malloc for s_ret_d: %s\n",
			 getpid(), strerror(errno));
		return ((passwd_users_t **)0);
	}
	if_printf(p_print_o, "malloc(%i): s_ret_d\n", l_name_user_all);

	if ((s_ret_s = (char *)malloc(l_name_user_max + l_check)) == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:: could't malloc for s_ret_s: %s\n",
			 getpid(), strerror(errno));
		return ((passwd_users_t **)0);
	}
	if_printf(p_print_o, "malloc(%i): s_ret_s\n", l_name_user_max);

	if ((s_ret_empty = (char *)malloc(l_name_user_all)) == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:: could't malloc for s_ret_empty: %s\n",
			 getpid(), strerror(errno));
		return ((passwd_users_t **)0);
	}
	i = 0;
	while (i < l_name_user_all) {
		*(s_ret_empty + i) = ' ';
		i++;
	}
	*(s_ret_empty + i) = 0;
	
	if ((s_ret_empty_s = (char *)malloc
		(l_name_user_max + l_check)) == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:: could't malloc for s_ret_empty_s: %s\n",
			 getpid(), strerror(errno));
		return ((passwd_users_t **)0);
	}
	if_printf(p_print_o, "malloc(%i): s_ret_empty_s\n", l_name_user_max);

	i = 0;
	while (i < l_name_user_max + l_check) {
		*(s_ret_empty_s + i) = ' ';
		i++;
	}
	*(s_ret_empty_s + i) = 0;
	l_name_user_all += l_name_user_max + 4;
	if ((s_rez_d = (char *)malloc(l_name_user_all + 1)) == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:: could't malloc for s_rez_d: %s\n",
			 getpid(), strerror(errno));
		return ((passwd_users_t **)0);
	}
	if_printf(p_print_o, "malloc(%i): s_rez_d\n", l_name_user_all);

	if ((s_rez_empty = (char *)malloc(l_name_user_all + 1)) == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:: could't malloc for s_rez_empty: %s\n",
			 getpid(), strerror(errno));
		return ((passwd_users_t **)0);
	}
	if_printf(p_print_o, "malloc(%i): s_rez_empty\n", l_name_user_all);

	if ((s_banner = (char *)malloc(l_name_user_all + 1)) == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:: could't malloc for s_banner: %s\n",
			 getpid(), strerror(errno));
		return ((passwd_users_t **)0);
	}
	if_printf(p_print_o, "malloc(%i): s_banner\n", l_name_user_all);
	
	p_banner = s_banner;
	while (p_banner - s_banner < l_name_user_all)
		*p_banner++ = ' ';
	*p_banner = 0;
	p_banner = s_banner + l_name_user_max + 3;
	*p_banner = 0;
	i = 0;
	while (pwd_current[i]) {
		strcat(p_banner, (pwd_current[i])->pw_name);
		if ((ddd = l_check - (pwd_current[i])->l_name) > 0)
			while (ddd--)
				strcat(p_banner, " ");
		i++;
	}

	i = 0;
	while (i < l_name_user_all)
		*(s_rez_empty + i++) = ' ';
	*(s_rez_empty + i) = 0;
	
//	if (i_am_main) {
/*
 *	Пересылка файлов tmac.cnf и tmac_exe на подчиненную машину
 */
//
//		com[0] = 0;
//		sprintf(com, "rcp %s %s:%s",
//			CONF_FILE, HOST, DIR_TMAC);
//		if_printf(p_print_Sh, "inic_host:2: try system(%s)\n", com);
//		if ((ret = system(com)) != 0) {
//			(void) fprintf(stderr,
//				"%i TMAC fail:1: could't system(%s)\n",
//				 getpid(), com);
//			return ((passwd_users_t **)0);
//		}
//		if_printf(p_print_Sh, "inic_host:3: ret: %i\n", ret);
//		
//		strcpy(TMAC_EXE, DIR_TMAC);
//		strcat(TMAC_EXE, "/");
//		strcat(TMAC_EXE, FILE_TMAC_EXE);
//		com[0] = 0;
//		sprintf(com, "rcp %s %s:%s",
//			TMAC_EXE, HOST, DIR_TMAC);
//		if_printf(p_print_Sh, "inic_host:4: try system(%s)\n", com);
//		if ((ret = system(com)) != 0) {
//			(void) fprintf(stderr,
//				"%i TMAC fail:2: could't system(%s)\n",
//				 getpid(), com);
//			return ((passwd_users_t **)0);
//		}
//		if_printf(p_print_Sh, "inic_host:5: ret: %i\n", ret);
//	}
//
	return (pwd_current);
}
 
int creat_obj(passwd_users_t **p_users_cnf)
{
	char		com[256];
	char		path_dir[256];
	char		path_file_mode[256];
	char		*path_dir_macdef = "/macdef_dir";
	char		*name_dir_serv = "tmac_serv";
	char		*name_macdef = "macdef";
	struct passwd	*passwd_user;
	int		ret;
	int		i;
	int		pid;
	int		status;

/*
 *	Создание тестовой директории tmac_dir в домашнем каталоге пользователей
 *	или в каталоге пользователя macdef
 */
	if ((passwd_user = getpwnam(name_macdef)) == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:: bad user: %s\n", getpid(), name_macdef);
		return (1);
	}
	if (macdef) {
		if ((ret = creat_df(path_dir_macdef, name_macdef,
				    passwd_user->pw_uid, passwd_user->pw_gid,
				    'd', 16895)) != 0) {
			(void) fprintf(stderr,
				"%i TMAC fail:creat_obj: creat_df(%s): %i\n",
				getpid(), name_macdef, ret);
			return (1);
		}
	} 
/*
 *	Создание директории tmac_serv в каталоге пользователя macdef
 *	В tmac_serv каждый сервер создает файл для обозначения факта запуска сервера. Основная программа дожидается создания всех файлов, после чего приступает к проверкам.
 */
	strcpy(path_dir_serv , path_dir_macdef);
	strcat(path_dir_serv, "/");
	strcat(path_dir_serv, name_dir_serv);
	if (access(path_dir_serv, F_OK) == 0) {
		strcpy(com, "rm -r ");
		strcat(com, path_dir_serv);
		if (system(com) != 0) {
			(void) fprintf(stderr,
				"%i TMAC fail:creat_obj: "
				"could't system(%s): %s\n",
				getpid(), com, strerror(errno));
			return (1);
		}
	}
	if ((mkdir(path_dir_serv, 0)) < 0) {
		(void) fprintf(stderr,
			"%i TMAC fail:creat_obj: could't mkdir(%s): %s\n",
			getpid(), path_dir_serv, strerror(errno));
		return (1);
	}
	if ((chmod(path_dir_serv, S_IRWXU | S_IRWXG | S_IRWXO)) < 0) {
		(void) fprintf(stderr,
		"%i TMAC fail:creat_obj: could't chmod(%s): %s\n",
		getpid(), path_dir_serv, strerror(errno));
		return (1);
	}
	if_printf(p_print_S, "creat_obj:: chmod(%s)\n", path_dir_serv);
	if ((chown(path_dir_serv,
		passwd_user->pw_uid, passwd_user->pw_gid)) < 0) {
		(void) fprintf(stderr,
		"TMAC fail:creat_obj: chown(%s): %s\n",
		path_dir_serv, strerror(errno));
		return (1);
	}
	if_printf(p_print_S, "creat_obj:: chown(%s)\n", path_dir_serv);
/*
 *	Создание серверов для проверки сокетов от имени каждого пользователя
 */
//	if (creat_server_lok(p_users_cnf)) {
//		(void) fprintf(stderr, "%i TMAC:creat_server == 1\n", getpid());
//		return (1);
//	}
//	if (i_am_main == 0) {
//		if_printf(p_print_p, "creat_obj:: "
//		"i_am_main: %i: exit(0)\n", i_am_main);
/*
 *	Работа на подчиненной машине закончена
 */
//		exit(0);
//	}
	if (inic_host() != 0) {
		(void) fprintf(stderr,
			"%i TMAC fail:creat_obj: inic_host() != 0\n",
			getpid());
		return (1);
	}

	i = 0;
	while (p_users_cnf[i]) {
		if (macdef)
			strcpy(path_dir, path_dir_macdef);
		else
			strcpy(path_dir, (p_users_cnf[i])->pw_dir);
		strcat(path_dir, "/");
		strcat(path_dir, (p_users_cnf[i])->pw_name);
		strcat(path_dir, "_dir_777");
		if ((ret = creat_df(path_dir, (p_users_cnf[i])->pw_name,
				    (p_users_cnf[i])->pw_uid,
				    (p_users_cnf[i])->pw_gid,
				    'd', 16895)) != 0) {
			(void) fprintf(stderr,
				"%i TMAC fail:creat_obj: creat_df(%s): %i\n",
				getpid(), (p_users_cnf[i])->pw_name, ret);
			return (1);
		}
/*
 *	Создание файлов в тестовой директории tmac_dir
 */
		if (macdef)
			strcpy(path_file_mode, path_dir_macdef);
		else
			strcpy(path_file_mode, (p_users_cnf[i])->pw_dir);
		strcat(path_file_mode, "/");
		strcat(path_file_mode, (p_users_cnf[i])->pw_name);
		strcat(path_file_mode, "_777");
		if ((ret = creat_df(path_file_mode, (p_users_cnf[i])->pw_name,
				    (p_users_cnf[i])->pw_uid,
				    (p_users_cnf[i])->pw_gid,
				    'f', 33279)) != 0) {
			(void) fprintf(stderr,
				"%i TMAC fail:creat_obj: creat_df(%s): %i\n",
				getpid(), (p_users_cnf[i])->pw_name, ret);
			return (1);
		}
#if 0 /// temporary
/*
 *	Создание объектов IPC 
 */
 		pid =  fork();
  		switch (pid) {
		case 0:
			if (setgid((p_users_cnf[i])->pw_gid) < 0 ||
			    setuid((p_users_cnf[i])->pw_uid) < 0) {
				(void) fprintf(stderr,
					"%i TMAC:creat IPC: cannot set "
					"%s uid %i gid %i "
					": errno %d (%s)\n"
					"\texit(1) pid %i\n",
					getpid(), 
					(p_users_cnf[i])->pw_name,
					(p_users_cnf[i])->pw_uid,
					(p_users_cnf[i])->pw_gid,
					errno, strerror(errno),
					getpid());
			}	
			
			ret = creat_msg(p_users_cnf[i]);
			if (ret) {
				(void) fprintf(stderr,
					"%i TMAC:creat IPC: "
					"creat_msg(%s) != 0\n",
					getpid(), p_users_cnf[i]->pw_name);
			}

//			if (ret = creat_sem(p_users_cnf[i])) {
//				(void) fprintf(stderr,
//					"%i TMAC:creat IPC: "
//					"creat_sem(%s) != 0\n",
//					getpid(), p_users_cnf[i]->pw_name);
//			}

			ret = creat_shm(p_users_cnf[i]);
			if (ret) {
				(void) fprintf(stderr,
					"%i TMAC:creat IPC: "
					"creat_shm(%s) != 0\n",
					getpid(), p_users_cnf[i]->pw_name);
			}

			if_printf(p_print_p,
 				"creat_obj: "
 				"exit(0) pid %i\n",
 				getpid());
			exit(0);
		case -1:
			(void) fprintf(stderr,
				"%i TMAC:fail:creat IPC:fork() %s: %s\n",
				getpid(), (p_users_cnf[i])->pw_name,
				strerror(errno));
			return (1);
		default:
			if_printf(p_print_p,
 				"creat_obj:IPC: parent %i created child %i\n",
 				getpid(), pid);
			pid = wait(&status);
			if_printf(p_print_p,
 				"creat_obj:IPC: parent %i waited child %i\n",
 				getpid(), pid);
		}
#endif
		i++;
	}

	return (0);
}

int check_access(passwd_users_t **p_users_cnf, passwd_users_t *p_user __attribute__ ((unused)))
{
	char path_dir[256];
	char path_file_mode[256];
	char *path_dir_macdef = "/macdef_dir";
	char *p_ret_d;
	int i;

	if_printf(p_print_f || p_print_d, "check_access: uid  %i gid  %i\n",
		getuid(), getgid());
	if_printf(p_print_f || p_print_d, "check_access: euid %i egid %i\n",
		geteuid(), getegid());

/* Проверка директорий */

	strcpy(s_ret_d, s_ret_empty);
	
	p_ret_d = s_ret_d;
	p_ret_d++;
	*p_ret_d++ = 'd';
	p_ret_d++;
	i = 0;
	while (p_users_cnf[i]) {
		if (macdef) {
			strcpy(path_dir, path_dir_macdef);
		} else
			strcpy(path_dir, (p_users_cnf[i])->pw_dir);
		strcpy(path_file_mode, path_dir);
		strcat(path_file_mode, "/");
		strcat(path_file_mode, (p_users_cnf[i])->pw_name);
		strcat(path_file_mode, "_dir_777");
		access_ret(path_file_mode, p_ret_d);
		l_name_user = (p_users_cnf[i])->l_name + 1;
		l_sdvig = l_name_user > l_check ? l_name_user : l_check;
		p_ret_d += l_sdvig;
		i++;
	}
	*p_ret_d = 0;
	if_printf(p_print_d, "check_access: s_ret_d: %s\n", s_ret_d);
	p_ret_d = s_rez_d;
	if_printf(p_print_d, "check_access: s_rez_d: %s\n", s_rez_d);
	while (*p_ret_d)
		p_ret_d++;
	while (p_ret_d - s_rez_d < l_name_user_max) {
		*p_ret_d++ = ' ';
	}
	*p_ret_d = 0;
	strcat(s_rez_d, s_ret_d);
	printf("%s\n", s_rez_d);
	
/* Проверка файлов */

	strcpy(s_ret_d, s_ret_empty);
	*(s_rez_d + l_name_user_max) = 0;
	
	p_ret_d = s_ret_d;
	p_ret_d++;
	*p_ret_d++ = '-';
	p_ret_d++;
	i = 0;
	while (p_users_cnf[i]) {
		if (macdef) {
			strcpy(path_dir, path_dir_macdef);
		} else
			strcpy(path_dir, (p_users_cnf[i])->pw_dir);
		strcpy(path_file_mode, path_dir);
		strcat(path_file_mode, "/");
		strcat(path_file_mode, (p_users_cnf[i])->pw_name);
		strcat(path_file_mode, "_777");
		access_ret(path_file_mode, p_ret_d);
		l_name_user = (p_users_cnf[i])->l_name + 1;
		l_sdvig = l_name_user > l_check ? l_name_user : l_check;
		p_ret_d += l_sdvig;
		i++;
	}
	*p_ret_d = 0;
	if_printf(p_print_f, "check_access: s_ret_d: %s\n", s_ret_d);
	p_ret_d = s_rez_d;
	if_printf(p_print_f, "check_access: s_rez_d: %s\n", s_rez_d);
	while (*p_ret_d)
		p_ret_d++;
	while (p_ret_d - s_rez_d < l_name_user_max) {
		*p_ret_d++ = ' ';
	}
	*p_ret_d = 0;
	strcat(s_rez_d, s_ret_d);
	printf("%s\n", s_rez_d);
	
#if 0 /// temporary
/* Проверка сообщений */

	strcpy(s_ret_d, s_ret_empty);
	*(s_rez_d + l_name_user_max) = 0;
	
	p_ret_d = s_ret_d;
	p_ret_d++;
	*p_ret_d++ = 'm';
	p_ret_d++;
	if (check_msg(p_users_cnf, p_ret_d) == 1) {
		(void) fprintf(stderr,
			"%i TMAC fail: check_msg == 1\n", getpid());
		return (1);
	}
	if_printf(p_print_m, "check_access: s_ret_d: %s\n", s_ret_d);
	p_ret_d = s_rez_d;
	if_printf(p_print_m, "check_access: s_rez_d: %s\n", s_rez_d);
	while (*p_ret_d)
		p_ret_d++;
	while (p_ret_d - s_rez_d < l_name_user_max) {
		*p_ret_d++ = ' ';
	}
	*p_ret_d = 0;
	strcat(s_rez_d, s_ret_d);
	printf("%s\n", s_rez_d);
	
/* Проверка семафоров */

//	strcpy(s_ret_d, s_ret_empty);
//	*(s_rez_d + l_name_user_max) = 0;
//	
//	p_ret_d = s_ret_d;
//	p_ret_d++;
//	*p_ret_d++ = 's';
//	p_ret_d++;
//	if (check_sem(p_users_cnf, p_ret_d) == 1) {
//		(void) fprintf(stderr,
//			"%i TMAC fail: check_sem == 1\n", getpid());
//		exit(1);
//	}
//	if_printf(p_print_s, "check_access: s_ret_d: %s\n", s_ret_d);
//	p_ret_d = s_rez_d;
//	if_printf(p_print_s, "check_access: s_rez_d: %s\n", s_rez_d);
//	while (*p_ret_d)
//		p_ret_d++;
//	while (p_ret_d - s_rez_d < l_name_user_max) {
//		*p_ret_d++ = ' ';
//	}
//	*p_ret_d = 0;
//	strcat(s_rez_d, s_ret_d);
//	printf("%s\n", s_rez_d);
	
/* Проверка разделяемой памяти */

	strcpy(s_ret_d, s_ret_empty);
	*(s_rez_d + l_name_user_max) = 0;
	
	p_ret_d = s_ret_d;
	p_ret_d++;
	*p_ret_d++ = 'r';
	p_ret_d++;
	if (check_shm(p_users_cnf, p_ret_d) == 1) {
		(void) fprintf(stderr,
			"%i TMAC fail: check_shm == 1\n", getpid());
		exit(1);
	}
	if_printf(p_print_shm, "check_access: s_ret_d: %s\n", s_ret_d);
	p_ret_d = s_rez_d;
	if_printf(p_print_shm, "check_access: s_rez_d: %s\n", s_rez_d);
	while (*p_ret_d)
		p_ret_d++;
	while (p_ret_d - s_rez_d < l_name_user_max) {
		*p_ret_d++ = ' ';
	}
	*p_ret_d = 0;
	strcat(s_rez_d, s_ret_d);
	printf("%s\n", s_rez_d);
	
/* Проверка сокетов на локальной машине*/
/*
	strcpy(s_ret_d, s_ret_empty);
	*(s_rez_d + l_name_user_max) = 0;
	
	p_ret_d = s_ret_d;
	p_ret_d++;
	*p_ret_d++ = 'L';
	p_ret_d++;
	if (check_socket(p_users_cnf, p_user, p_ret_d, 1) == 1) {
		(void) fprintf(stderr,
			"%i TMAC fail: check_socket == 1\n", getpid());
		exit(1);
	}
	if_printf(p_print_S, "check_access: s_ret_d: %s\n", s_ret_d);
	p_ret_d = s_rez_d;
	if_printf(p_print_S, "check_access: s_rez_d: %s\n", s_rez_d);
	while (*p_ret_d)
		p_ret_d++;
	while (p_ret_d - s_rez_d < l_name_user_max) {
		*p_ret_d++ = ' ';
	}
	*p_ret_d = 0;
	strcat(s_rez_d, s_ret_d);
	printf("%s\n", s_rez_d);
*/	
/* Проверка сокетов на удаленной машине*/
/*
	strcpy(s_ret_d, s_ret_empty);
	*(s_rez_d + l_name_user_max) = 0;
	
	p_ret_d = s_ret_d;
	p_ret_d++;
	*p_ret_d++ = 'H';
	p_ret_d++;
	if (check_socket(p_users_cnf, p_user, p_ret_d, 0) == 1) {
		(void) fprintf(stderr,
			"%i TMAC fail: check_socket == 1\n", getpid());
		exit(1);
	}
	if_printf(p_print_S, "check_access: s_ret_d: %s\n", s_ret_d);
	p_ret_d = s_rez_d;
	if_printf(p_print_S, "check_access: s_rez_d: %s\n", s_rez_d);
	while (*p_ret_d)
		p_ret_d++;
	while (p_ret_d - s_rez_d < l_name_user_max) {
		*p_ret_d++ = ' ';
	}
	*p_ret_d = 0;
	strcat(s_rez_d, s_ret_d);
	printf("%s\n", s_rez_d);
*/
#endif
	return (0);
}

int check_access_users(passwd_users_t **p_users_cnf)
{
	pid_t	pid;
	pid_t	pidwait;
	int	status;
//int	j;
//char	**p_user;
//char	path_dir[256];
//char	path_file[256];
//char	path_file_mode[256];
//char	*path_dir_macdef = "/macdef_dir";
//char	*name_dir = "tmac_dir";
//char	*name_macdef = "macdef";
//char	*name_file = "tmac_file";
//struct	passwd	*passwd_user;
//passwd_users_t	**p_users_cnf_dub;

	if (i_am_main == 0) {
		if_printf(p_print_p,
		"check_access_users: i_am_main == 0: return (0)\n");
		return (0);
	}
	if (p_users_cnf == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:check_access_users:1: "
			"p_users_cnf == NULL\n", getpid());
		return (1);
	}
	//p_users_cnf_dub = p_users_cnf;
	printf("%s\n", s_banner);
	i = 0;
	while (p_users_cnf[i]) {
		printf("\n");
		strcpy(s_rez_d, s_rez_empty);
		strcpy(s_rez_d, (p_users_cnf[i])->pw_name);
		switch (pid = fork()) {
		case 0:
#if 0 /// temporary
			if (send_msg(p_users_cnf))
				(void) fprintf(stderr,
					"%i TMAC: check_access_users:1.1: "
					"send_msg(p_users_cnf) != 0 %s\n",
					getpid(),
					(p_users_cnf[i])->pw_name);
#endif
			if (setgid((p_users_cnf[i])->pw_gid) < 0 ||
			    setuid((p_users_cnf[i])->pw_uid) < 0) {
				(void) fprintf(stderr,
					"%i TMAC: check_access_users:2: "
					"cannot set uid %i gid %i, "
					"errno %d (%s)\n"
					"exit(1) pid %i\n",
					getpid(),
					(p_users_cnf[i])->pw_uid,
					(p_users_cnf[i])->pw_gid,
					errno, strerror(errno), getpid());
				exit(1);
			}
			if_printf(p_print_d || p_print_f || p_print_m,
				"check_access_users:3: child: %s uid  %i\n",
				(p_users_cnf[i])->pw_name,
				(p_users_cnf[i])->pw_uid);
			if_printf(p_print_d || p_print_f || p_print_m,
				"check_access_users:4: s_rez_d: %s\n",
				s_rez_d);
			if (check_access(p_users_cnf, (p_users_cnf[i])) != 0) {
				(void) fprintf(stderr,
					"%i TMAC: check_access != 0\n"
					"exit(1) pid %i\n",
					getpid(), getpid());
				exit(1);
			}
			if_printf(p_print_p,
 				"\tcheck_access_users:5: "
 				"exit(0) pid %i\n",
 				getpid());
			exit(0);
		case -1:
			(void) fprintf(stderr,
				"%i TMAC: check_access_users:6: "
				"cannot fork() uid %i gid %i, "
				"errno %d (%s)\n",
				getpid(),
				(p_users_cnf[i])->pw_uid,
				(p_users_cnf[i])->pw_gid,
				errno, strerror(errno));
			break;
		default:
			if_printf(p_print_p,
 				"check_access_users:7: "
 				"parent %i created child %i "
 				"for check_access()\n",
 				getpid(), pid);
eee:			pidwait = waitpid(pid, &status, 0);
 			if (pidwait < 0) {
			(void) fprintf(stderr,
				"%i TMAC: check_access_users:8: "
				"waitpid < 0 uid %i gid %i, "
				"errno %d (%s)\n",
				getpid(),
				(p_users_cnf[i])->pw_uid,
				(p_users_cnf[i])->pw_gid,
				errno, strerror(errno));
				if (errno == 4)
					goto eee;
			}
			if (WIFEXITED(status))	
				if_printf(p_print_p,
 					"check_access_users:9: "
 					"parent %i waited child %i "
 					"WEXITSTATUS(status): %i\n",
 					getpid(), pidwait, WEXITSTATUS(status));
			if (WIFSIGNALED(status))	
				if_printf(p_print_p,
 					"check_access_users:10: "
 					"parent %i waited child %i "
 					"WTERMSIG(status): %i\n",
 					getpid(), pidwait, WTERMSIG(status));
			if (WIFSTOPPED(status))	
				if_printf(p_print_p,
 					"check_access_users:11: "
 					"parent %i waited child %i "
 					"WSTOPSIG(status): %i\n",
 					getpid(), pidwait, WSTOPSIG(status));
		}
	i++;	
	}
	return (0);
}

void
if_printf(int p, const char *format, ...)
{
	va_list	ap;
	char s[1024];
	if (p) {
		va_start(ap, format);
		if (strlen(format) > 1020)
			(void) fprintf(stderr,
				"%i if_printf: strlen(format) > 1020\n",
				getpid());
		else {
			sprintf(s, "%i %s", getpid(), format);
			(void) vfprintf(stderr, s, ap);
		}
		va_end(ap);
	}
}

void
access_ret(char *path_file_mode, char *p_ret_d)
{
	if (access(path_file_mode, F_OK) == 0) {
		if_printf(p_print_d || p_print_f,
			"%s F_OK  YES\n", path_file_mode);
		if (access(path_file_mode, R_OK) == 0) {
			if_printf(p_print_d || p_print_f,
				"%s R_OK YES\n", path_file_mode);
			*(p_ret_d + 0) = 'r';
		} else {
			if_printf(p_print_d || p_print_f,
				"%s R_OK %s\n",
				path_file_mode, strerror(errno));
			*(p_ret_d + 0) = 'p';
		}
		if (access(path_file_mode, W_OK) == 0) {
			if_printf(p_print_d || p_print_f,
				"%s W_OK YES\n", path_file_mode);
			*(p_ret_d + 1) = 'w';
		} else {
			if_printf(p_print_d || p_print_f,
				"%s W_OK %s\n",
				path_file_mode, strerror(errno));
			*(p_ret_d + 1) = 'p';
		}
		if (access(path_file_mode, X_OK) == 0) {
			if_printf(p_print_d || p_print_f,
				"%s X_OK YES\n", path_file_mode);
			*(p_ret_d + 2) = 'x';
		} else {
			if_printf(p_print_d || p_print_f,
				"%s X_OK %s\n",
				path_file_mode, strerror(errno));
			*(p_ret_d + 2) = 'p';
		}
	} else
		if_printf(p_print_d || p_print_f,
			"%s F_OK %s\n",
			path_file_mode, strerror(errno));
}


int
check_msg(passwd_users_t **p_users_cnf, char *p_ret_d)
{
	int	p_msg;
	struct	msqid_ds	msg_stat;
	
	if (p_users_cnf == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:check_msg: p_users_cnf == NULL\n",
			getpid());
		return (1);
	}
	i = 0;
	while (p_users_cnf[i]) {
		i_msg = (p_users_cnf[i])->pw_uid + 1;
		if ((p_msg = msgget(i_msg, 0)) < 0) {
			switch (errno) {
			case EACCES:
			case EPERM:
				*(p_ret_d + 0) = 'p';
				break;
			case ENOENT:
				*(p_ret_d + 0) = '#';
				break;
			default:
				(void) fprintf(stderr,
					"%i check_msg: "
					"%s: msgget(%i, 0): "
					"%s errno: %i\n",
					getpid(),
					(p_users_cnf[i])->pw_name,
					p_msg, strerror(errno), errno);
				*(p_ret_d + 0) = '?';
			}
			*(p_ret_d + 1) = '-';
			*(p_ret_d + 2) = '-';
			*(p_ret_d + 3) = '-';
			*(p_ret_d + 4) = '-';
			goto continu;
		} else
			*(p_ret_d + 0) = 'g';
			
		if_printf(p_print_m,
			"check msg: %s p_msg: %i OK\n",
			(p_users_cnf[i])->pw_name, p_msg);

		if ((msgctl(p_msg, IPC_STAT, &msg_stat)) < 0) {
			switch (errno) {
			case EACCES:
			case EPERM:
				*(p_ret_d + 1) = 'p';
				break;
			default:
				(void) fprintf(stderr,
					"%i check_msg: "
					"%s: msgctl(%i, IPC_STAT): "
					"%s errno: %i\n",
					getpid(),
					(p_users_cnf[i])->pw_name,
					p_msg, strerror(errno), errno);
				*(p_ret_d + 1) = '?';
			}
		} else
			*(p_ret_d + 1) = 'c';

		if_printf(p_print_work,
			"checking user: %s\n", (p_users_cnf[i])->pw_name);
		if_printf(p_print_work,
			"msg_stat.msg_cbytes: %i\n", msg_stat.msg_cbytes);
		if_printf(p_print_work,
			"msg_stat.msg_qnum: %i\n", msg_stat.msg_qnum);
		if_printf(p_print_work,
			"msg_stat.msg_qbytes: %i\n", msg_stat.msg_qbytes);

		if ((msgctl(p_msg, IPC_SET, &msg_stat)) < 0) {
			switch (errno) {
			case EACCES:
			case EPERM:
				*(p_ret_d + 2) = 'p';
				break;
			default:
				*(p_ret_d + 2) = '?';
				(void) fprintf(stderr,
					"%i check_msg: "
					"%s: msgctl(%i, IPC_SET): "
					"%s errno: %i\n",
					getpid(),
					(p_users_cnf[i])->pw_name,
					p_msg, strerror(errno), errno);
			}
		} else
			*(p_ret_d + 2) = 's';

		if (msg_stat.msg_qnum > 0) {
			if ((ret = msgrcv(p_msg, &msg_rcv,
				MSGMAX, 0, IPC_NOWAIT)) < 0) {
//				MSGMAX, 0, 0)) < 0) {
				switch (errno) {
				case EACCES:
				case EPERM:
					*(p_ret_d + 3) = 'p';
					break;
				default:
					*(p_ret_d + 3) = '?';
					(void) fprintf(stderr,
						"%i check_msg: "
						"%s: msgrcv(%i, 10): "
						"%s errno: %i\n",
						getpid(),
						(p_users_cnf[i])->pw_name,
						p_msg, strerror(errno), errno);
				}
			} else
				*(p_ret_d + 3) = 'r';
				
			if ((ret = msgsnd(p_msg, &msg_snd,
				strlen(msg_snd.mtext) + 1, IPC_NOWAIT)) < 0) {
				switch (errno) {
				case EACCES:
				case EPERM:
					*(p_ret_d + 4) = 'p';
					break;
				default:
					*(p_ret_d + 4) = '?';
					(void) fprintf(stderr,
						"%i check_msg: "
						"%s: msgsnd(%i, 1): "
						"%s errno: %i\n",
						getpid(),
						(p_users_cnf[i])->pw_name,
						p_msg, strerror(errno), errno);
				}
			} else
				*(p_ret_d + 4) = 's';
		} else {
			if ((ret = msgsnd(p_msg, &msg_snd,
				strlen(msg_snd.mtext) + 1, IPC_NOWAIT)) < 0) {
				switch (errno) {
				case EACCES:
				case EPERM:
					*(p_ret_d + 4) = 'p';
					break;
				default:
					*(p_ret_d + 4) = '?';
					(void) fprintf(stderr,
						"%i check_msg: "
						"%s: msgsnd(%i, 2): "
						"%s errno: %i\n",
						getpid(),
						(p_users_cnf[i])->pw_name,
						p_msg, strerror(errno), errno);
				}
			} else
				*(p_ret_d + 4) = 's';
				
			if ((ret = msgrcv(p_msg, &msg_rcv,
				MSGMAX, 0, IPC_NOWAIT)) < 0) {
				switch (errno) {
				case EACCES:
				case EPERM:
					*(p_ret_d + 3) = 'p';
					break;
				default:
					*(p_ret_d + 3) = '?';
					(void) fprintf(stderr,
						"%i check_msg: "
						"%s: msgrcv(%i, 2): "
						"%s errno: %i\n",
						getpid(),
						(p_users_cnf[i])->pw_name,
						p_msg, strerror(errno), errno);
				}
			} else
				*(p_ret_d + 3) = 'r';
		}
		if_printf(p_print_m,
			"msg_stat.msg_qnum: %i\n", msg_stat.msg_qnum);

continu:	l_name_user = (p_users_cnf[i])->l_name + 1;
		l_sdvig = l_name_user > l_check ? l_name_user : l_check;
		p_ret_d += l_sdvig;
		i++;
	}
	*p_ret_d = 0;
	return (0);
}

int
creat_msg(passwd_users_t *p_users_cnf)
{
//	char	**p_user;
//	int	ret;
//	int	i;
	int	p_msg;
//	struct	passwd	*passwd_user;

	if (p_users_cnf == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:creat_msg: p_users_cnf == NULL\n",
			getpid());
		return (0);
	}
	if_printf(p_print_work, "creat_msg: numel: %i\n", numel);
	i_msg = p_users_cnf->pw_uid + 1;
	if ((p_msg = msgget(i_msg, 0)) > 0) {
		(void) fprintf(stderr,
			"%i TMAC fail:creat_msg: %s message %i - EXIST\n",
			getpid(), p_users_cnf->pw_name, i_msg);
		if ((msgctl(p_msg, IPC_RMID, 0)) < 0) {
			(void) fprintf(stderr,
				"%i TMAC fail:creat_msg: %s could't "
				"msgctl(%i, IPC_RMID, 0): %s errno: %i\n",
				getpid(), p_users_cnf->pw_name,
				p_msg, strerror(errno), errno);
			return (1);
		}
	}
	if ((p_msg = msgget(i_msg, IPC_CREAT | 0777)) < 0) {
		(void) fprintf(stderr,
			"%i TMAC fail:creat_msg: %s could't "
			"msgget(%i, IPC_CREAT | 0777): %s errno: %i\n",
			getpid(), p_users_cnf->pw_name,
			i_msg, strerror(errno), errno);
		return (1);
	}
	if_printf(p_print_m, "Creat msg: %s: p_msg: %i i_msg: %i\n",
		p_users_cnf->pw_name,
		p_msg, i_msg);
		
	return (0);
}

int
delete_msg(passwd_users_t **p_users_cnf)
{
//	char	**p_user;
	int	p_msg;
//	struct	passwd	*passwd_user;

	if (p_users_cnf == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:delete_msg: p_users_cnf == NULL\n",
			getpid());
		return (1);
	}
	i = 0;
	while (p_users_cnf[i]) {
		i_msg = (p_users_cnf[i])->pw_uid + 1;
		if ((p_msg = msgget(i_msg, 0)) < 0) {
			if_printf(p_print_m,
				"TMAC fail:Delete msg: could't msgget"
				"(%i, 0) for %s: %s\n",
				i_msg, (p_users_cnf[i])->pw_name,
				strerror(errno));
			goto con;
		}
		if_printf(p_print_m,
			"%i = msgget(%i, 0): %s\n",
				p_msg, i_msg, (p_users_cnf[i])->pw_name);
		if ((msgctl(p_msg, IPC_RMID, 0)) < 0) {
			if_printf(p_print_m,
				"TMAC fail:Delete msg: %s: could't "
				"msgctl(%i, IPC_RMID, 0): %s\n",
				(p_users_cnf[i])->pw_name,
				p_msg, strerror(errno));
			goto con;
		}
		if_printf(p_print_m,
			"Delete msg: msgctl(%i, IPC_RMID, 0) for %s\n",
			p_msg, (p_users_cnf[i])->pw_name);
con:		i++;	
	}
	return (0);
}

/*
 *	Функция инициализации элемента списка атрибутов пользователя
 */
 
passwd_users_t	*
init_user()
{
	passwd_users_t	*result = (passwd_users_t *)NULL;
	
	result = (passwd_users_t *)
		malloc(sizeof (passwd_users_t));
	if (result != (passwd_users_t *)NULL) {
		result->pw_name = (char *)NULL;
		result->pw_uid = (int)-1;
		result->pw_gid = (int)-1;
		result->pw_dir = (char *)NULL;
		result->next = (passwd_users_t *)NULL;
	} else {
		(void)fprintf(stderr,
			"%i init_user():"
		    	" unable to allocate memory (%d) %s\n",
		    	getpid(), (int)errno, strerror(errno));
	}
	return (result);
}

/*
 *	Функция заполнения элемента списка атрибутов пользователя
 */
 
passwd_users_t	*
obtain_user(char *name_user)
{
	struct passwd *passwd_user;
	passwd_users_t	*pwd_user = (passwd_users_t *)NULL;
	int	l_name;


	if (name_user == NULL) {
		(void) fprintf(stderr,
		"%i obtain_user fail:: name_user == NULL\n", getpid());
		return ((passwd_users_t *)NULL);
	}

	if ((pwd_user = (passwd_users_t *)init_user())
		== (passwd_users_t *)0) {
		(void) fprintf(stderr,
		"%i obtain_user fail:: init_user() == NULL\n", getpid());
		return ((passwd_users_t *)NULL);
	}
	
	if ((passwd_user = getpwnam(name_user)) == NULL) {
		(void) fprintf(stderr,
		"%i obtain_user fail:: getpwnam(%s): %s\n",
		getpid(), name_user, strerror(errno));
		return ((passwd_users_t *)NULL);
	}

	l_name = strlen(name_user);
	if ((pwd_user->pw_name = (char *)malloc(l_name))
		== NULL) {
		(void) fprintf(stderr,
		"%i obtain_user fail:: pwd_user->pw_name = malloc(%i): %s\n",
		getpid(), l_name, strerror(errno));
		return ((passwd_users_t *)NULL);
	}
	
	strcpy(pwd_user->pw_name, name_user);
	pwd_user->l_name = l_name;
	if ((pwd_user->pw_dir = (char *)malloc(strlen(passwd_user->pw_dir)))
		== NULL) {
		(void) fprintf(stderr,
		"%i obtain_user fail:: pwd_user->pw_dir = malloc(%i): %s\n",
		getpid(), strlen(passwd_user->pw_dir), strerror(errno));
		return ((passwd_users_t *)NULL);
	}
	
	strcpy(pwd_user->pw_dir, passwd_user->pw_dir);

	pwd_user->pw_uid = passwd_user->pw_uid;
	pwd_user->pw_gid = passwd_user->pw_gid;
	

	return (pwd_user);
}

int
creat_df(char *name_df, char *name_user,
	int uid, int gid, char type, int type_st_mode)
{
	struct stat	buf_stat;
	char	type_obj;
	char	com[256];
	
	if_printf(p_print_c,
		"call creat_df\n");
	if_printf(p_print_c,
		"	name_df:: %s\n", name_df);
	if_printf(p_print_c,
		"	name_user:: %s\n", name_user);
	if_printf(p_print_c,
		"	uid:: %i\n", uid);
	if_printf(p_print_c,
		"	gid:: %i\n", gid);
	if_printf(p_print_c,
		"	type:: %c\n", type);
	if_printf(p_print_c,
		"	type_st_mode:: %i\n", type_st_mode);
		
	if ((access(name_df, F_OK)) != 0) {
		if_printf(p_print_c,
			"creat_df:: access(f_OK) != 0\n");
		goto creat;
	}
	if (stat(name_df, &buf_stat)) {
		if_printf(p_print_c,
			"creat_df:: stat() != 0\n");
		(void) fprintf(stderr,
			"%i creat_df:: could't stat for %s : %s\n",
			getpid(), name_df, strerror(errno));
		exit(1);
	}
	if (buf_stat.st_mode & S_IFIFO)
		type_obj = 'p';
	else
		if (buf_stat.st_mode & S_IFCHR)
			type_obj = 'c';
		else
			if (buf_stat.st_mode & S_IFDIR)
				type_obj = 'd';
			else
				if (buf_stat.st_mode & S_IFBLK)
					type_obj = 'b';
				else
					if (buf_stat.st_mode & S_IFREG)
						type_obj = 'f';
					else
						type_obj = 'z';
						
	if_printf(p_print_c,
		"%s %c %i%i%i%i%i%i%i%i%i %c%c %i %s %i %i\n",
		name_df,
		type_obj,
		buf_stat.st_mode & S_IRUSR ? 1 : 0,
		buf_stat.st_mode & S_IWUSR ? 1 : 0,
		buf_stat.st_mode & S_IXUSR ? 1 : 0,
		buf_stat.st_mode & S_IRGRP ? 1 : 0,
		buf_stat.st_mode & S_IWGRP ? 1 : 0,
		buf_stat.st_mode & S_IXGRP ? 1 : 0,
		buf_stat.st_mode & S_IROTH ? 1 : 0,
		buf_stat.st_mode & S_IWOTH ? 1 : 0,
		buf_stat.st_mode & S_IXOTH ? 1 : 0,
		buf_stat.st_mode & S_ISUID ? 'S' : ' ',
		buf_stat.st_mode & S_ISGID ? 'G' : ' ',
		buf_stat.st_uid,
		name_user,
		buf_stat.st_gid,
		buf_stat.st_mode);
		
	if (type != type_obj) {
		if (type == 'd')
			strcpy(com, "rm -r ");
		else
			strcpy(com, "rm ");
		strcat(com, name_df);
		system(com);
		if_printf(p_print_c,
			"creat_df:: %s\n", com);
		goto creat;
	}
	if (buf_stat.st_mode != type_st_mode) {
		if ((chmod(name_df, S_IRWXU | S_IRWXG | S_IRWXO)) < 0) {
			(void) fprintf(stderr,
			"%i TMAC fail:creat_df: chmod(%s): %s\n",
			getpid(), name_df, strerror(errno));
			return (1);
		} else
			if_printf(p_print_c,
				"creat_df:: chmod(%s)\n", name_df);
	}
	if (uid != buf_stat.st_uid || gid != buf_stat.st_gid) {
		if ((chown(name_df, uid, gid)) < 0) {
			(void) fprintf(stderr,
			"%i TMAC fail:creat_df: chown(%s): %s\n",
			getpid(), name_df, strerror(errno));
			return (1);
		} else
			if_printf(p_print_c,
				"creat_df:: chown(%s)\n", name_df);
	}
	if_printf(p_print_c,
		"creat_df:: return (0)\n");
	return (0);
	
creat:
	if (type == 'd') {
		if_printf(p_print_c, "type == 'd'\n");
		if ((mkdir(name_df, 0)) < 0) {
			(void) fprintf(stderr,
				"%i TMAC fail:creat_df: "
				"could't mkdir(%s): %s\n",
				getpid(), name_df, strerror(errno));
			return (1);
		}
	} else
		if (type == 'f') {
			if_printf(p_print_c, "type == 'f'\n");
			if ((ret = open
				(name_df, O_WRONLY | O_CREAT | O_TRUNC, 0))
				< 0) {
				(void) fprintf(stderr,
					"%i TMAC fail:creat_df: open(%s): %s\n",
					getpid(), name_df, strerror(errno));
				return (1);
			}
			errno = 0;
			close(ret);
			if_printf(p_print_c, "creat_df: open %s; close %s\n",
				name_df, strerror(errno));
		} else {
			(void) fprintf(stderr,
				"%i TMAC fail:creat_df: type == %c\n",
				getpid(), type);
			return (1);
		}
	if_printf(p_print_c, "creat_df: type == %c\n", type);
	if_printf(p_print_c, "creat_df: creat %s\n", name_df);
	if ((access(name_df, F_OK)) != 0) {
		if_printf(p_print_c,
			"creat_df:: access(f_OK) != 0\n");
		return (1);
	}
	if ((chown(name_df, uid, gid)) < 0) {
		(void) fprintf(stderr,
			"%i TMAC fail:creat_df: chown(%s): %s\n",
			getpid(), name_df, strerror(errno));
		return (1);
	}
	if_printf(p_print_c, "creat_df: chown(%s. %i, %i)\n",
		name_df, uid, gid);
	if ((chmod(name_df, S_IRWXU | S_IRWXG | S_IRWXO)) < 0) {
		(void) fprintf(stderr,
			"%i TMAC fail:creat_df: chmod(%s): %s\n",
			getpid(), name_df, strerror(errno));
		return (1);
	}
	if_printf(p_print_c, "creat_df: chmod(%s. %i)\n",
		name_df, S_IRWXU | S_IRWXG | S_IRWXO);
	return (0);
}



int
check_shm(passwd_users_t **p_users_cnf, char *p_ret_d)
{
	int	p_shm;
	int	i_shm;
	struct	shmid_ds	shmbuf;
	char	*p_shmat;
//	char	s_shmat[STRSIZE];
		
	if (p_users_cnf == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:check_sem: p_users_cnf == NULL\n",
			getpid());
		return (1);
	}
	i = 0;
	while (p_users_cnf[i]) {
		i_shm = (p_users_cnf[i])->pw_uid + 100;
		if ((p_shm = shmget(i_shm, SHMSIZE, 0)) < 0) {
			if_printf(p_print_shm,
				"check_shm: %s: shmget(%i, 0): %s\n",
				(p_users_cnf[i])->pw_name,
				i_shm, strerror(errno));
			switch (errno) {
			case EACCES:
			case EPERM:
				*(p_ret_d + 0) = 'p';
				break;
			case ENOENT:
				*(p_ret_d + 0) = '#';
				break;
			default:
				*(p_ret_d + 0) = '?';
			}
			*(p_ret_d + 1) = '-';
			*(p_ret_d + 2) = '-';
			*(p_ret_d + 3) = '-';
			*(p_ret_d + 4) = '-';
			*(p_ret_d + 5) = '-';
			goto continu;
		}
		*(p_ret_d + 0) = 'g';
			
		if (shmctl(p_shm, IPC_STAT, &shmbuf) < 0) {
			if_printf(p_print_shm,
				"check_shm: %s: shmctl(%i, 0, IPC_STAT): %s\n",
				(p_users_cnf[i])->pw_name,
				i_shm, strerror(errno));
			switch (errno) {
			case EACCES:
			case EPERM:
				*(p_ret_d + 1) = 'p';
				break;
			default:
				*(p_ret_d + 1) = '?';
			}
		} else
			*(p_ret_d + 1) = 'c';
		
		if (shmctl(p_shm, IPC_SET, &shmbuf) < 0) {
			if_printf(p_print_shm,
				"check_shm: %s: i_shm %i "
				"shmctl(IPC_SET): %s\n",
				(p_users_cnf[i])->pw_name,
				i_shm, strerror(errno));
			switch (errno) {
			case EACCES:
			case EPERM:
				*(p_ret_d + 2) = 'p';
				break;
			default:
				*(p_ret_d + 2) = '?';
			}
		} else
			*(p_ret_d + 2) = 's';
		if ((p_shmat = (char *)shmat(p_shm, 0, 0)) == (char *)-1) {
			if_printf(p_print_shm,
				"check_shm: %s: i_shm %i shmat(): %s\n",
				(p_users_cnf[i])->pw_name,
				i_shm, strerror(errno));
			switch (errno) {
			case EACCES:
			case EPERM:
				*(p_ret_d + 3) = 'p';
				break;
			default:
				*(p_ret_d + 3) = '?';
			}
			*(p_ret_d + 4) = '-';
			goto continu;
		} else
			*(p_ret_d + 3) = 'a';
		if (shmdt(p_shmat) < 0) {
			if_printf(p_print_shm,
				"check_shm: %s: i_shm %i shmdt(p_shmat): %s\n",
				(p_users_cnf[i])->pw_name,
				i_shm, strerror(errno));
			switch (errno) {
			case EACCES:
			case EPERM:
				*(p_ret_d + 4) = 'p';
				break;
			default:
				*(p_ret_d + 4) = '?';
			}
		} else
			*(p_ret_d + 4) = 'd';
continu:	l_name_user = (p_users_cnf[i])->l_name + 1;
		l_sdvig = l_name_user > l_check ? l_name_user : l_check;
		p_ret_d += l_sdvig;
		i++;
	}
	*p_ret_d = 0;
	return (0);
}
/**
int
check_sem(passwd_users_t **p_users_cnf, char *p_ret_d)
{
	int	p_sem;
	char	p_rez_sem[1024];
	union	semun {
		int	val;
		struct	semid_ds	*mbuf;
		ushort	*array;
	}	arg;
	struct	semid_ds	mbuf;
	struct	sembuf	plus_sem[1] = {{0, 1, SEM_UNDO | IPC_NOWAIT}};
	struct	sembuf	minus_sem[1] = {{0, -1, SEM_UNDO | IPC_NOWAIT}};
	struct	sembuf	null_sem[1] = {{0, 0, SEM_UNDO | IPC_NOWAIT}};
	
	arg.mbuf = &mbuf;
	if (p_users_cnf == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:check_sem: p_users_cnf == NULL\n",
			getpid());
		return (1);
	}
	i = 0;
	while (p_users_cnf[i]) {
		i_sem = (p_users_cnf[i])->pw_uid + 1;
		if ((p_sem = semget(i_sem, 0, 0)) < 0) {
			switch (errno) {
			case EACCES:
			case EPERM:
				*(p_ret_d + 0) = 'p';
				break;
			case ENOENT:
				*(p_ret_d + 0) = '#';
				break;
			default:
				*(p_ret_d + 0) = '?';
				break;
			}
			*(p_ret_d + 1) = '-';
			*(p_ret_d + 2) = '-';
			*(p_ret_d + 3) = '-';
			*(p_ret_d + 4) = '-';
			*(p_ret_d + 5) = '-';
			goto continu;
		}
		*(p_ret_d + 0) = 'g';
			
		if (semctl(p_sem, 0, IPC_STAT, arg) < 0) {
			if_printf(p_print_s,
				"check_sem: %s: semctl(%i, 0, IPC_STAT): %s "
				"errno: %i\n",
				(p_users_cnf[i])->pw_name,
				i_sem, strerror(errno), errno);
			switch (errno) {
			case EACCES:
			case EPERM:
				*(p_ret_d + 1) = 'p';
				break;
			default:
				*(p_ret_d + 1) = '?';
			}
		} else
			*(p_ret_d + 1) = 'c';
		
		if (semctl(p_sem, 0, IPC_SET, arg) < 0) {
			if_printf(p_print_s,
				"check_sem: %s: semctl(%i, 0, IPC_SET): %s "
				"errno: %i\n",
				(p_users_cnf[i])->pw_name,
				i_sem, strerror(errno), errno);
			switch (errno) {
// need			case EACCES:
			case EPERM:
				*(p_ret_d + 2) = 'p';
				break;
			default:
				*(p_ret_d + 2) = '?';
			}
		} else
			*(p_ret_d + 2) = 's';
		if (semop(p_sem, plus_sem, 1) < 0) {
			if_printf(p_print_s,
				"check_sem: %s: semop(%i, plus_sem, 1): %s "
				"errno: %i\n",
				(p_users_cnf[i])->pw_name,
				i_sem, strerror(errno), errno);
			switch (errno) {
			case EACCES:
			case EPERM:
				*(p_ret_d + 3) = 'p';
				break;
			default:
				*(p_ret_d + 3) = '?';
			}
		} else
			*(p_ret_d + 3) = '+';
		if (semop(p_sem, minus_sem, 1) < 0) {
			if_printf(p_print_s,
				"check_sem: %s: semop(%i, minus_sem, 1): %s "
				"errno: %i\n",
				(p_users_cnf[i])->pw_name,
				i_sem, strerror(errno), errno);
			switch (errno) {
			case EACCES:
			case EPERM:
				*(p_ret_d + 4) = 'p';
				break;
			default:
				*(p_ret_d + 4) = '?';
			}
		} else
			*(p_ret_d + 4) = 'm';
		if (semop(p_sem, null_sem, 1) < 0) {
			if_printf(p_print_s,
				"check_sem: %s: semop(%i, null_sem, 1): %s "
				"errno: %i\n",
				(p_users_cnf[i])->pw_name,
				i_sem, strerror(errno), errno);
			switch (errno) {
			case EACCES:
			case EPERM:
				*(p_ret_d + 5) = 'p';
				break;
			default:
				*(p_ret_d + 5) = '?';
			}
		} else
			*(p_ret_d + 5) = 'n';
continu:	l_name_user = (p_users_cnf[i])->l_name + 1;
		l_sdvig = l_name_user > l_check ? l_name_user : l_check;
		p_ret_d += l_sdvig;
		i++;
	}
	*p_ret_d = 0;
	return (0);
}
**/
/*
int
creat_sem(passwd_users_t *p_users_cnf)
{
	int	p_sem;

	if (p_users_cnf == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:creat_sem: p_users_cnf == NULL\n",
			getpid());
		return (1);
	}
	if_printf(p_print_s,
		"creat_sem: %s pid %i\n",
		p_users_cnf->pw_name, getpid());
		
 	i_sem = p_users_cnf->pw_uid + 1;
	if ((p_sem = semget(i_sem, 0, 0)) > 0) {
		(void) fprintf(stderr,
			"%i TMAC:creat_sem: %s i_sem: "
			"%i - EXIST. Try IPC_RMID\n",
			getpid(), p_users_cnf->pw_name, i_sem);
		if ((semctl(p_sem, 0, IPC_RMID, 0)) < 0) {
			(void) fprintf(stderr,
				"%i TMAC fail:creat_sem: %s "
				"semctl(%i, 0, IPC_RMID, 0)) < 0: "
				"%s errno: %i\n",
				getpid(), p_users_cnf->pw_name, p_sem,
				strerror(errno), errno);
			return (1);
		}
	}
	if ((p_sem = semget(i_sem, 2, IPC_CREAT | 0777)) < 0) {
		(void) fprintf(stderr,
			"%i TMAC fail:creat_sem: %s "
			"semget(%i, 2, IPC_CREAT | 0777)) < 0: "
			"%s errno: %i\n",
			getpid(), p_users_cnf->pw_name, i_sem,
			strerror(errno), errno);
		return (1);
	}
	if_printf(p_print_s,
		"creat_sem: %s: p_sem: %i i_sem: %i\n",
		p_users_cnf->pw_name,
		p_sem, i_sem);
		
	return (0);
}
*/
int
creat_shm(passwd_users_t *p_users_cnf)
{
	int	p_shm;
	int	i_shm;
//	struct	shmid_ds	sbuf;

	if (p_users_cnf == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:creat_shm: p_users_cnf == NULL\n",
			getpid());
		return (1);
	}
		
 	i_shm = p_users_cnf->pw_uid + 100;
	if ((p_shm = shmget(i_shm, 0, 0)) > 0) {
		(void) fprintf(stderr,
			"%i TMAC fail:creat_shm: "
			"%s i_shm: %i - EXIST. Try IPC_RMID\n",
			getpid(), p_users_cnf->pw_name, i_shm);
		if ((shmctl(p_shm, IPC_RMID, 0)) < 0) {
			if_printf(p_print_shm,
				"%i TMAC fail:creat_shm: %s: "
				"shmctl(%i, IPC_RMID, 0) < 0: %s errno: %i\n",
				getpid(), p_users_cnf->pw_name,
				p_shm, strerror(errno), errno);
			return (1);
		}
	}
	if ((p_shm = shmget(i_shm, SHMSIZE, IPC_CREAT | 0777)) < 0) {
		(void) fprintf(stderr,
			"%i TMAC fail:creat_shm: %s "
			"shmget(%i, %i, IPC_CREAT | 0777)) < 0: "
			"%s errno: %i\n",
			getpid(), p_users_cnf->pw_name, i_shm, SHMSIZE,
			strerror(errno), errno);
		return (1);
	}
	if_printf(p_print_shm,
		"creat_shm: %s: p_shm: %i i_shm: %i\n",
		p_users_cnf->pw_name,
		p_shm, i_shm);
		
	return (0);
}
/**
int
delete_sem(passwd_users_t **p_users_cnf)
{
	int	p_sem;

	if (p_users_cnf == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:delete_sem: p_users_cnf == NULL\n",
			getpid());
		return (1);
	}
	i = 0;
	while (p_users_cnf[i]) {
		i_sem = (p_users_cnf[i])->pw_uid + 1;
		if ((p_sem = semget(i_sem, 0, 0)) < 0) {
			if_printf(p_print_s,
				"TMAC fail:delete_sem: could't semget"
				"(%i, 0, 0) for %s: %s\n",
				i_sem, (p_users_cnf[i])->pw_name,
				strerror(errno));
			goto con;
		}
		if_printf(p_print_s,
			"%i = semget(%i, 0, 0): %s OK\n",
				p_sem, i_sem, (p_users_cnf[i])->pw_name);
		if ((semctl(p_sem, 0, IPC_RMID, 0)) < 0) {
			if_printf(p_print_s,
				"TMAC fail:delete_sem: %s: could't "
				"semctl(%i, 0, IPC_RMID, 0): %s\n",
				(p_users_cnf[i])->pw_name,
				p_sem, strerror(errno));
			goto con;
		}
		if_printf(p_print_s,
			"delete_sem: semctl(%i, 0, IPC_RMID, 0)) for %s OK\n",
			p_sem, (p_users_cnf[i])->pw_name);
con:		i++;	
	}
	return (0);
}
**/
int
delete_shm(passwd_users_t **p_users_cnf)
{
	int	p_shm;
	int	i_shm;

	if (p_users_cnf == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:delete_shm: p_users_cnf == NULL\n",
			getpid());
		return (1);
	}
	i = 0;
	while (p_users_cnf[i]) {
		i_shm = (p_users_cnf[i])->pw_uid + 100;
		if ((p_shm = shmget(i_shm, 0, 0)) < 0) {
			if_printf(p_print_shm,
				"TMAC fail:delete_shm: could't shmget"
				"(%i, 0, 0) for %s: %s\n",
				i_shm, (p_users_cnf[i])->pw_name,
				strerror(errno));
			goto con;
		}
		if_printf(p_print_shm,
			"%i = shmget(%i, 0, 0): %s OK\n",
				p_shm, i_shm, (p_users_cnf[i])->pw_name);
		if ((shmctl(p_shm, IPC_RMID, 0)) < 0) {
			if_printf(p_print_shm,
				"TMAC fail:delete_shm: %s: could't "
				"shmctl(%i, 0, IPC_RMID, 0): %s\n",
				(p_users_cnf[i])->pw_name,
				p_shm, strerror(errno));
			goto con;
		}
		if_printf(p_print_shm,
			"delete_shm: shmctl(%i, 0, IPC_RMID, 0)) for %s OK\n",
			p_shm, (p_users_cnf[i])->pw_name);
con:		i++;	
	}
	return (0);
}

//int
//creat_server_lok(passwd_users_t **p_users_cnf)
//{
//	int	pid;
//	int	pid_server;
//	int	pidwait;
//	int	status;
//	int	count = 0;
//	int	counts = 0;
//	int	l = 0;
//	Dirent*	dp;
//	DIR*	fd;
//	FILE	*f1;
//	char	s[STRSIZE];
//	char	s_pid_server[STRSIZE];
//	char	*p_ret_d;

//	if (p_users_cnf == NULL) {
//		(void) fprintf(stderr,
//			"%i TMAC fail:creat_server_lok:0: "
//			"p_users_cnf == NULL\n", getpid());
//		return (1);
//	}
//	if_printf(p_print_S,
//		"creat_server_lok:1: pid parent %i\n", pid_parent);
//		
//	if (i_am_main == 0) {
/*
 *	Создание на подчиненной машине служебного сервера для убиения серверов после окончания проверки. Сообщение об этом ожидается с главной машины, где оно формируется в функции delete_obj().
 */
//		pid_server_cpecial = 0;
// 		switch (pid_server_cpecial = fork()) {
// 		case -1:
//			(void) fprintf(stderr,
//				"%i TMAC fail:creat_server_lok:2: "
//				"i_am_main == 0:"
//				"fork() == -1\n", getpid());
//			return (1);
//		case 0:
// 			if (server_cpecial() < 0) {
//				(void) fprintf(stderr,
//					"%i TMAC:creat_server_lok:3: "
//					"server_cpecial() < 0 %s\n"
//					"exit(1).\n",
//					getpid()
//					);
//				exit(1);
//			}
//			exit(0);
//		default:
//			if_printf(p_print_SPEC,
//				"creat_server_lok:3: i_am_main == 0: "
//				"created child %i for server_cpecial\n",
//				pid_server_cpecial);
//		}
//	}		
/*
 *	Создание серверов для проверки взаимодействия
 */
/*
	sigset(SIGUSR1, fun_sig_ign);
	i = 0;
	while (p_users_cnf[i]) {
		count_users++;
		if_printf(p_print_S,
			"creat_server_lok:5: try fork for %s\n",
			(p_users_cnf[i])->pw_name);
		switch (pid = fork()) {
		case 0:
			if_printf(p_print_S,
				"creat_server_lok:6: "
				"try server_socket_tcp for %s\n",
				(p_users_cnf[i])->pw_name);
			strcpy(path_file_serv, path_dir_serv);
			strcat(path_file_serv, "/serv_");
			strcat(path_file_serv, (p_users_cnf[i])->pw_name);

			strcpy(s_ret_s, s_ret_empty_s);
			p_ret_d = s_ret_s;
			p_ret_d++;
			if (i_am_main == 0)
				*p_ret_d++ = 'h';
			else
				*p_ret_d++ = 'l';
			p_ret_d++;
			ret = server_socket_tcp((p_users_cnf[i]), p_ret_d);
			strcpy(s_rez_d, (p_users_cnf[i])->pw_name);
			l = (p_users_cnf[i])->l_name;
			while (l < l_name_user_max) {
				strcat(s_rez_d, " ");
				l++;
			}
			strcat(s_rez_d, s_ret_s);
			(void) fprintf(stderr, "%s\n", s_rez_d);
			if (ret) {
				if ((f1 = fopen(path_file_serv, "w")) == NULL) {
					(void) fprintf(stderr,
						"%i TMAC fail:"
						"creat_server_lok:7.1: "
						"fopen(%s): %s\n",
						getpid(),
						path_file_serv,
						strerror(errno));
					exit(1);
				}
				if_printf(p_print_p,
					"creat_server_lok:7.11: "
					"fopened(%s, w)\n", path_file_serv);
				if (fputs("0", f1) == EOF) {
					(void) fprintf(stderr,
						"%i TMAC fail:"
						"creat_server_lok:7.2: "
						"fputs(%s, 0): %s\n",
						getpid(),
						path_file_serv,
						strerror(errno));
					exit(1);
				}
				if_printf(p_print_p,
					"creat_server_lok:7.21: "
					"fputsed(0, %s)\n", path_file_serv);
				fclose(f1);
				exit(1);
			}	
			if_printf(p_print_p,
				"creat_server_lok:8: exit(0) pid %i\n",
				getpid());
			exit(0);
		case -1:
			(void) fprintf(stderr,
				"%i TMAC:fail:creat_server_lok:9: "
				"fork() %s: %s\n",
				getpid(), (p_users_cnf[i])->pw_name,
				strerror(errno));
			return (1);
		default:
			if_printf(p_print_S,
				"creat_server_lok:10: %s pid server %i\n",
				(p_users_cnf[i])->pw_name, pid);
			if_printf(p_print_p,
 				"creat_server_lok:11: "
 				"parent %i created child %i "
 				"for server_socket_tcp %s\n",
 				getpid(), pid, (p_users_cnf[i])->pw_name);
		}
		i++;
	}
	count_file = 0;
*/
/*
 *	Ожидание выхода на accept() серверов
 */
/*
 	while (count_file != count_users) {
		if_printf(p_print_pid,
			"creat_server_lok:12: count_file %i count_users %i\n",
			 count_file, count_users);
		count_file = 0;
		if (!(fd = opendir(path_dir_serv))) {
			(void) fprintf(stderr,
				"%i TMAC:fail:creat_server_lok:13: "
				"opendir(%s): %s\n",
				getpid(), path_dir_serv, strerror(errno));
			return (1);
		}
		if_printf(p_print_S,
			"creat_server_lok:14: opendir(%s)\n", path_dir_serv);
		for (; dp = readdir(fd);) {
			if (strcmp(dp->d_name, ".") &&
			    strcmp(dp->d_name, "..")) {
				count_file++;
				if_printf(p_print_pid,
					"creat_server_lok:15: dp->d_name: %s "
					"count_file: %i\n",
					 dp->d_name, count_file);
			}
		}
		closedir(fd);
	}
*/
/*
 *	Заполнение полей pid_server значениями номеров процессов-серверов из файлов.
 */
/*
	if (!(fd = opendir(path_dir_serv))) {
		(void) fprintf(stderr,
			"%i TMAC:fail:creat_server_lok:13.1: "
			"opendir(%s): %s\n",
			getpid(), path_dir_serv, strerror(errno));
		return (1);
	}
	if_printf(p_print_S,
		"creat_server_lok:14: openeddir(%s)\n", path_dir_serv);
	for (; dp = readdir(fd);) {
		if_printf(p_print_pid,
			"creat_server_lok:15.1: dp->d_name: %s\n", dp->d_name);
		if (strcmp(dp->d_name, ".") &&
		    strcmp(dp->d_name, "..")) {
			i = 0;
			while (p_users_cnf[i]) {
				if_printf(p_print_pid,
					"creat_server_lok:15.1.0: "
					"(p_users_cnf[i])->pw_name: %s\n",
					 (p_users_cnf[i])->pw_name);
				if (strstr(dp->d_name,
					(p_users_cnf[i])->pw_name))
					break;
				i++;
			}
			if (p_users_cnf[i] == NULL) {
				(void) fprintf(stderr,
					"%i TMAC:fail:creat_server_lok:15.1.1: "
					"p_users_cnf[i] == NULL\n", getpid());
				return (1);
			}
			strcpy(path_file_serv, path_dir_serv);
			strcat(path_file_serv, "/");
			strcat(path_file_serv, 	dp->d_name);
			if_printf(p_print_pid,
				"creat_server_lok:15.2: "
				"try fopen: %s\n",
				path_file_serv);
			(p_users_cnf[i])->pid_server = 0;
rrr:			if ((f1 = fopen(path_file_serv, "r")) == NULL) {
				(void) fprintf(stderr,
				"%i TMAC:fail:creat_server_lok:15.3: "
				"fopen(%s, r): %s\n",
				getpid(),
				path_file_serv,
				strerror(errno));
				(p_users_cnf[i])->pid_server = 0;
			} else {
				if_printf(p_print_pid,
					"creat_server_lok:15.4: "
					"fopened: %s\n",
					 path_file_serv);
				if_printf(p_print_pid,
					"creat_server_lok:15.4.1: "
					"try fgets: %s\n",
					path_file_serv);
				if (fgets(s_pid_server, STRSIZE, f1) == NULL) {
					if ((p_users_cnf[i])->pid_server++
						< 20) {
						fclose(f1);
						sleep(1);
						goto rrr;
					}
					(void) fprintf(stderr,
						"%i TMAC:fail:"
						"creat_server_lok:15.4.2: "
						"fgets(%s) == NULL: %i\n",
						getpid(),
						dp->d_name,
						(p_users_cnf[i])->pid_server);
					(p_users_cnf[i])->pid_server = 0;
				} else {
					if_printf(p_print_pid,
						"creat_server_lok:15.4.3: "
						"fgetsed(%s) %s\n",
						 path_file_serv, s_pid_server);
					(p_users_cnf[i])->pid_server =
							  atoi(s_pid_server);
				}
				fclose(f1);
			}
			if_printf(p_print_pid,
				"creat_server_lok:17: "
				"->pw_name: %s "
				"->pid_server: %i\n",
				(p_users_cnf[i])->pw_name,
				(p_users_cnf[i])->pid_server);
		}
	}
	closedir(fd);
	
	if (i_am_main == 0) {
*/
/*
 *	Ответ главной машине о том, что серверы созданы. Ответ главная машина ожидает в функции inic_host() - server_cpecial_2()
 */
/*
		int	s;
		int	rez_send;
		int	rez_bind;
		int	rez_connect;
		struct	sockaddr_in	clnt_addr;
		struct	hostent	*hp;
		char	buf[80];
		hp = gethostbyname(HOST);
	
		if (hp == 0) {
			(void) fprintf(stderr,
				"%i creat_server_lok:16.1: "
				"gethostbyname !!! FAIL !!! %s\n",
				getpid(), strerror(errno));
			return (1);
		}
		bzero(&clnt_addr, sizeof (clnt_addr));
		bcopy(hp->h_addr, &clnt_addr.sin_addr, hp->h_length);
		clnt_addr.sin_family = hp->h_addrtype;
		clnt_addr.sin_port = htons(CPEC_PORT);
		if_printf(p_print_S,
			"creat_server_lok:17.1: gethostbyname:\n"
			"clnt_addr.sin_addr %s\n"
			"clnt_addr.sin_port %i\n",
			inet_ntoa(clnt_addr.sin_addr),
			clnt_addr.sin_port);

		errno = 0;
		s = socket(AF_INET, SOCK_STREAM, 0);
		if (s == -1) {
			(void) fprintf(stderr,
				"%i creat_server_lok:18: "
				"socket !!! FAIL !!! %s\n",
				getpid(), strerror(errno));
			return (1);
		}
		rez_connect = connect(s, (struct sockaddr *)&clnt_addr,
					sizeof (clnt_addr));
		if (rez_connect < 0) {
			(void) fprintf(stderr,
				"%i creat_server_lok:19: connect FAIL !!! %s\n",
				getpid(), strerror(errno));
			close(s);
			return (1);
		}
		if_printf(p_print_S, "creat_server_lok:20: connect: %i\n",
			rez_connect);
		errno = 0;
		buf[0] = 0;
		sprintf(buf,
			"1:from: %s uid: %i to host: %s port: %i",
			HOST_LOCK, getuid(),
			inet_ntoa(clnt_addr.sin_addr),
			clnt_addr.sin_port);
		
		if_printf(p_print_S,
			"creat_server_lok:21: try send(%s)\n", buf);
	
		rez_send = send(s, buf, sizeof (buf), 0);
		if (rez_send == -1) {
			(void) fprintf(stderr,
				"%i creat_server_lok:22: send == -1 "
				"!!! FAIL !!! %s\n",
				 getpid(), strerror(errno));
			close(s);
			return (1);
		}
			
		if_printf(p_print_S || p_print_send,
			"creat_server_lok:23: send(%s)\n", buf);
				
		if (recv(s, buf, sizeof (buf), 0) < 0) {
			(void) fprintf(stderr,
				"%i creat_server_lok:24: recv "
				"!!! FAIL !!! %s\n",
				 getpid(), strerror(errno));
			close(s);
			return (1);
		}
			
		if_printf(p_print_S || p_print_recv,
			"creat_server_lok:25: recv(%s)\n", buf);
		
		close(s);
*/
/*
 *	Ожидание завершения процесса pid_server_cpecial
 */
/*
		if_printf(p_print_p,
 			"creat_server_lok:26: i_am_main: %i pid: %i "
 			"try waitpid(pid_server_cpecial: %i)\n",
 			i_am_main, getpid(), pid_server_cpecial);
 			
eee:		pidwait = waitpid(pid_server_cpecial, &status, 0);

 		if (pidwait < 0) {
			(void) fprintf(stderr,
				"%i TMAC: creat_server_lok:27: "
				"waitpid(pid_server_cpecial: %i) < 0: "
				"errno %d (%s)\n",
				getpid(), pid_server_cpecial,
				errno, strerror(errno));
				if (errno == 4)
					goto eee;
		}
		if (WIFEXITED(status))	
			if_printf(p_print_p,
 				"creat_server_lok:28: "
 				"parent %i waited child "
 				"pid_server_cpecial %i "
 				"WEXITSTATUS(status): %i\n",
 				getpid(), pidwait, WEXITSTATUS(status));
		if (WIFSIGNALED(status))	
			if_printf(p_print_p,
 				"creat_server_lok:29: "
 				"parent %i waited child "
 				"pid_server_cpecial %i "
 				"WTERMSIG(status): %i\n",
 				getpid(), pidwait, WTERMSIG(status));
		if (WIFSTOPPED(status))	
			if_printf(p_print_p,
 				"creat_server_lok:30: "
 				"parent %i waited child "
 				"pid_server_cpecial %i "
 				"WSTOPSIG(status): %i\n",
 				getpid(), pidwait, WSTOPSIG(status));
 		i = 0;
		while (p_users_cnf[i]) {
			if_printf(p_print_p,
 				"creat_server_lok:31: try kill(SIGUSR2) "
				"p_users_cnf[i]->pw_name: %s "
				"p_users_cnf[i]->pid_server: %i\n",
				(p_users_cnf[i])->pw_name,
				(p_users_cnf[i])->pid_server);
			if (kill((p_users_cnf[i])->pid_server, SIGUSR2) < 0) {
				(void) fprintf(stderr,
					"%i TMAC: creat_server_lok:32: "
					"kill(%i, SIGUSR2) < 0: "
					"errno %d (%s)\n",
					getpid(), (p_users_cnf[i])->pid_server,
					errno, strerror(errno));
			}
			i++;
		}
	}
	return (0);
}

int
delete_server(passwd_users_t **p_users_cnf)
{
	int	pid;
	int	i;

	if (p_users_cnf == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:delete_server: p_users_cnf == NULL\n",
			getpid());
		return (1);
	}
	i = 0;
	while (p_users_cnf[i]) {
		if_printf(p_print_kill,
			"delete_server: ->pw_name: %s; ->pid_server: %i\n",
			(p_users_cnf[i])->pw_name,
			(p_users_cnf[i])->pid_server);
		if ((p_users_cnf[i])->pid_server)
		if (kill((p_users_cnf[i])->pid_server, SIGUSR2)) {
			(void) fprintf(stderr,
				"%i TMAC fail:delete_server: "
				"kill(%i, SIGUSR2) != 0 for %s: %s\n",
				getpid(), (p_users_cnf[i])->pid_server,
				(p_users_cnf[i])->pw_name,
				strerror(errno));
		} 
		i++;
	}
	return (0);
*/
//}

void
fun_sig_ign(int sig)
{
	sigset(sig, fun_sig_ign);
	if_printf(p_print_sig, "fun_sig_ign: pid %i\n", getpid());
	count_sigs++;
	if_printf(p_print_sig,
		"fun_sig_ign: count_users %i count_sigs %i\n",
		count_users, count_sigs);
}

void
del_sign(int sig)
{
	sigset(sig, del_sign);
	if_printf(p_print_long, "del_sign: pid %i\n", getpid());
	longjmp(env, sig);
}
/*
int
check_socket(passwd_users_t **p_users_cnf,
	     passwd_users_t *p_user,
	     char *p_ret_d,
	     int host_lok)
{
	int	s;
	int	pid;
	int	i;
	int	l;
	int	res;
	int	rez_send;
	int	rez_bind;
	int	rez_connect;
	struct	sockaddr_in	serv_addr;
	struct	hostent	*hp;
	char	buf[80];

	if (p_users_cnf == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:check_socket: p_users_cnf == NULL\n",
			getpid());
		return (1);
	}
	if (p_user == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:check_socket: p_user == NULL\n",
			getpid());
		return (1);
	}
	if (host_lok != 0 && host_lok != 1) {
		(void) fprintf(stderr,
			"%i TMAC fail:check_socket: host_lok != (0 | 1)\n",
			getpid());
		return (1);
	}
	hp = gethostbyname(host_lok ? HOST_LOCK : HOST);
	if (hp == 0) {
		(void) fprintf(stderr,
			"%i client_socket_tcp:: "
			"gethostbyname !!! FAIL !!! %s\n",
			getpid(), strerror(errno));
		return (1);
	}
	bzero(&serv_addr, sizeof (serv_addr));
	bcopy(hp->h_addr, &serv_addr.sin_addr, hp->h_length);
	serv_addr.sin_family = hp->h_addrtype;
	
	i = 0;
	while (p_users_cnf[i]) {
*/
/*
 * Проверка возможности создания клиента, соединяющегося с портом 
 * nport1 в файле tmac.cnf,
 * закрепленным за сервером проверяемого пользователя
 */
/*
		errno = 0;
		s = socket(AF_INET, SOCK_STREAM, 0);
		if (s == -1) {
			(void) fprintf(stderr,
				"%i check_socket:: socket !!! FAIL !!! %s\n",
				getpid(), strerror(errno));
			switch (errno) {
			case EACCES:
			case EPERM:
				*(p_ret_d + 0) = 'p';
				break;
			default:
				*(p_ret_d + 0) = '?';
			}
			*(p_ret_d + 1) = '-';
			*(p_ret_d + 2) = '-';
			*(p_ret_d + 3) = '-';
			*(p_ret_d + 4) = '-';
			goto continu;
		}
		*(p_ret_d + 0) = 's';
		if_printf(p_print_S, "check_socket:2: socket: %i\n", s);

		errno = 0;
		serv_addr.sin_port = htons((p_users_cnf[i])->nport);
		if_printf(p_print_S,
			"check_socket:1: getuid %i geteuid %i\n",
			getuid(), geteuid());
		if_printf(p_print_S,
			"check_socket:1: gethostbyname: "
			"serv_addr.sin_addr %s\n",
			inet_ntoa(serv_addr.sin_addr));
		if_printf(p_print_S,
			"check_socket:1: gethostbyname: "
			"serv_addr.sin_port %i\n",
			serv_addr.sin_port);

		rez_connect = connect(s, (struct sockaddr *)&serv_addr,
					sizeof (serv_addr));
		if (rez_connect == -1) {
			if_printf(p_print_S, "check_socket:2.1: "
				"connect == -1: %s\n", strerror(errno));
			switch (errno) {
			case ECONNREFUSED:
				*(p_ret_d + 1) = '#';
			case EACCES:
			case EPERM:
				*(p_ret_d + 1) = 'p';
				break;
			default:
				*(p_ret_d + 1) = '?';
			}
			*(p_ret_d + 2) = '-';
			*(p_ret_d + 3) = '-';
		} else {
			*(p_ret_d + 1) = 'c';
			if_printf(p_print_S, "check_socket:3: connect: %i\n",
				rez_connect);

			errno = 0;
			buf[0] = 0;
			strcpy(buf, "2: from ");
			strcat(buf, p_user->pw_name);
			strcat(buf, " to ");
			strcat(buf, (p_users_cnf[i])->pw_name);
			if_printf(p_print_S, "check_socket:4: try send(%s)\n",
				 buf);
			rez_send = send(s, buf, sizeof (buf), 0);
			if (rez_send == -1) {
				(void) fprintf(stderr,
					"%i check_socket:5: send "
					"!!! FAIL !!! %s\n",
					 getpid(), strerror(errno));
				*(p_ret_d + 2) = '?';
				*(p_ret_d + 3) = '-';
			} else {
				*(p_ret_d + 2) = 's';
				if_printf(p_print_S || p_print_send,
					"check_socket:6: send(%s)\n", buf);
				
				if (recv(s, buf, sizeof (buf), 0) < 0) {
					(void) fprintf(stderr,
						"%i check_socket:6: recv "
						"!!! FAIL !!! %s\n",
						 getpid(), strerror(errno));
					*(p_ret_d + 3) = '?';
				} else {
					*(p_ret_d + 3) = 'r';
					if_printf(p_print_S || p_print_recv,
						"check_socket:6: "
						"recv(%s)\n", buf);
				}
			}
		}
		close(s);
		
		if (host_lok == 0)
			goto continu;
*/
/*
 * Проверка возможности создания сервера, ожидающего запросов по порту 
 * nport2 в файле tmac.cnf для проверяемого пользователя
 */
/*
		serv_addr.sin_port = htons((p_users_cnf[i])->nport2);
		if_printf(p_print_S,
			"check_socket:7: getuid %i geteuid %i\n",
			getuid(), geteuid());
		if_printf(p_print_S,
			"check_socket:7: gethostbyname: "
			"serv_addr.sin_addr %s\n",
			inet_ntoa(serv_addr.sin_addr));
		if_printf(p_print_S,
			"check_socket:7: gethostbyname: "
			"serv_addr.sin_port %i\n",
			serv_addr.sin_port);

		s = socket(AF_INET, SOCK_STREAM, 0);
		if (s == -1) {
			(void) fprintf(stderr,
				"%i check_socket:7.1: socket for bind %s\n",
				getpid(), strerror(errno));
			switch (errno) {
			case EACCES:
			case EPERM:
				*(p_ret_d + 4) = 'p';
				break;
			default:
				*(p_ret_d + 4) = '?';
			}
			*(p_ret_d + 5) = '-';
			goto continu;
		}
		*(p_ret_d + 4) = 's';
		res = 1;
		res = setsockopt(s, SOL_SOCKET, SO_REUSEADDR, (char *)&res, 4);
		if (res == -1) {
			(void) fprintf(stderr,
				"%i check_socket:7.2: "
				"setsockopt == -1 !!! %s errno %i\n",
				getpid(), errno,
				strerror(errno));
		}
		rez_bind = bind(s,
			(struct sockaddr *)&serv_addr, sizeof (serv_addr));
		if (rez_bind == -1) {
			switch (errno) {
			case EACCES:
			case EPERM:
				*(p_ret_d + 5) = 'p';
				break;
			default:
				*(p_ret_d + 5) = '?';
				(void) fprintf(stderr,
					"%i check_socket:7.3: "
					"bind == -1: %s errno: %i\n",
					getpid(), strerror(errno), errno);
				(void) fprintf(stderr,
					"%i getuid %i geteuid %i "
					"nport %i %s %i\n",
					getpid(), getuid(), geteuid(),
					(p_users_cnf[i])->nport,
					(p_users_cnf[i])->pw_name,
					(p_users_cnf[i])->pw_uid);
			}
		} else
			*(p_ret_d + 5) = 'b';

		close(s);
		
continu:
		if_printf(p_print_S, "check_socket:7: "
			"client end !!! OK !!!\n");
		l_name_user = (p_users_cnf[i])->l_name + 1;
		l_sdvig = l_name_user > l_check ? l_name_user : l_check;
		p_ret_d += l_sdvig;
		i++;
	}
	*p_ret_d = 0;
	return (0);
}

int
server_socket_tcp(passwd_users_t *p_users_cnf, char *p_ret_d)
{
int	s;
int	ns;
int	pid;
int	nport;
int	i;
int	l;
int	ret;
int	res;
int	rez_listen;
int	rez_bind;
int	my_pid;
struct	sockaddr_in	serv_addr;
struct	sockaddr_in	clnt_addr;
struct	hostent	*hp;
char	buf[80];
char	buf_send[80];
char	pid_server[256];
FILE	*f1;

	if (p_users_cnf == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:server_socket_tcp:1: "
			"p_users_cnf == NULL\n", getpid());
		return (1);
	}
	if (setjmp(env) == 0) {
		sigset(SIGUSR2, del_sign);
	} else {
		close(s);
		if_printf(p_print_long,
			"server_socket_tcp:28: setjmp(env) != 0 "
			"server end !!! OK !!!\n");
		return (0);
	}
	nport = htons(p_users_cnf->nport);
	my_pid = getpid();
	
	if_printf(p_print_S,
		"server_socket_tcp:2:%i: begin for %s port %i\n",
		my_pid, p_users_cnf->pw_name, nport);

	if (setgid(p_users_cnf->pw_gid) < 0 ||
 	    setuid(p_users_cnf->pw_uid) < 0) {
		(void) fprintf(stderr,
			"%i TMAC:server_socket_tcp:3:%i: "
			"cannot set uid %i gid %i, "
			"errno %d (%s)\n",
			getpid(), my_pid, 
			p_users_cnf->pw_uid,
			p_users_cnf->pw_gid,
			errno, strerror(errno));
			return (1);
	}
	if_printf(p_print_S,
		"server_socket_tcp:4:%i: setuid %i setgid %i\n",
		my_pid, getuid(), getgid());
	s = socket(AF_INET, SOCK_STREAM, 0);
	if (s == -1) {
		switch (errno) {
		case EACCES:
		case EPERM:
			*(p_ret_d + 0) = 'p';
			break;
		default:
			*(p_ret_d + 0) = '?';
			(void) fprintf(stderr,
				"%i server_socket_tcp:5: socket == -1: "
				"%s errno: %i\n",
				getpid(), strerror(errno), errno);
		}
		*(p_ret_d + 1) = '-';
		*(p_ret_d + 2) = '-';
		*(p_ret_d + 3) = '-';
		return (1);
	}
	res = 1;
	res = setsockopt(s, SOL_SOCKET, SO_REUSEADDR, (char *)&res, 4);
	if (res == -1) {
		(void) fprintf(stderr,
			"%i server_socket_tcp:5.1: "
			"setsockopt == -1 !!! %s errno %i\n",
			getpid(), errno,
			strerror(errno));
		close(s);
		return (1);
	}
	*(p_ret_d + 0) = 's';
	if_printf(p_print_S, "server_socket_tcp:6:%i: socket: %i\n",
		my_pid, s);

	bzero(&serv_addr, sizeof (serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = INADDR_ANY;
	serv_addr.sin_port = nport;

	errno = 0;
	if_printf(p_print_S, "server_socket_tcp:7:%i: try bind:\n"
		"\tserv_addr.sin_addr.s_addr %s\n"
		"\tserv_addr.sin_port %i\n",
		my_pid,
		inet_ntoa(serv_addr.sin_addr),
		serv_addr.sin_port);
	rez_bind = bind(s, (struct sockaddr *)&serv_addr, sizeof (serv_addr));
	if (rez_bind == -1) {
		switch (errno) {
		case EADDRINUSE:
			*(p_ret_d + 1) = 'u';
			break;
		case EACCES:
		case EPERM:
			*(p_ret_d + 1) = 'p';
			break;
		default:
			*(p_ret_d + 1) = '?';
			(void) fprintf(stderr,
				"%i server_socket_tcp:8: "
				"bind == -1: %s errno: %i\n",
				getpid(), strerror(errno), errno);
			(void) fprintf(stderr,
				"%i getuid %i geteuid %i "
				"nport %i %s %i\n",
				getpid(), getuid(), geteuid(),
				p_users_cnf->nport,
				p_users_cnf->pw_name,
				p_users_cnf->pw_uid);
		}
		*(p_ret_d + 2) = '-';
		*(p_ret_d + 3) = '-';
		close(s);
		return (1);
	}
	*(p_ret_d + 1) = 'b';
	if_printf(p_print_S, "server_socket_tcp:10:%i: bind: %i\n",
		my_pid, rez_bind);

	errno = 0;
	rez_listen = listen(s, 5);
	if (rez_listen == -1) {
		switch (errno) {
		case EACCES:
		case EPERM:
			*(p_ret_d + 2) = 'p';
			break;
		default:
			*(p_ret_d + 2) = '?';
			(void) fprintf(stderr,
				"%i: server_socket_tcp:11: "
				"listen == -1: %s errno: %i\n",
				 getpid(), strerror(errno), errno);
		}
		*(p_ret_d + 3) = '-';
		close(s);
		return (1);
	}
	*(p_ret_d + 2) = 'l';
	if_printf(p_print_S, "server_socket_tcp:12: listen: %i\n", rez_listen);

	if_printf(p_print_S,
		"server_socket_tcp:13: try creat(%s)\n", path_file_serv);
	if ((f1 = fopen(path_file_serv, "w")) == NULL) {
		(void) fprintf(stderr,
			"%i TMAC fail:server_socket_tcp:14: "
			"fopen(%s): %s\n",
			getpid(), path_file_serv, strerror(errno));
		close(s);
		return (1);
	}
	if_printf(p_print_pid,
		"server_socket_tcp:13.2: fopened(%s, %s)\n",
		path_file_serv, pid_server);
	sprintf(pid_server, "%i", getpid());
	if (fputs(pid_server, f1) == EOF) {
		(void) fprintf(stderr,
			"%i TMAC fail:server_socket_tcp:14: "
			"fputs(%s): %s\n",
			getpid(), path_file_serv, strerror(errno));
		close(s);
		return (1);
	}
	fclose(f1);
	if_printf(p_print_pid,
		"server_socket_tcp:13.1: fputsed(%s, %s)\n",
		path_file_serv, pid_server);
	while(1) {
		int addrlen;
		addrlen = sizeof (clnt_addr);
		bzero(&clnt_addr, addrlen);

		if_printf(p_print_S,
			"server_socket_tcp:15: try accept()\n");
		
		ns = accept(s, (struct sockaddr *)&clnt_addr, &addrlen);
		if (ns == -1) {
			switch (errno) {
			case EACCES:
			case EPERM:
				*(p_ret_d + 3) = 'p';
				break;
			default:
				*(p_ret_d + 3) = '?';
				(void) fprintf(stderr,
					"%i server_socket_tcp:16: "
					"accept == -1: %s errno: %i\n",
					getpid(), strerror(errno), errno);
			}
			close(s);
			return (1);
		}
		*(p_ret_d + 3) = 'a';
		if_printf(p_print_S,
			"server_socket_tcp:17: accept: %i\n"
			"\tclnt_addr.sin_addr.s_addr %s\n"
			"\tclnt_addr.sin_port %i\n",
			ns,
			inet_ntoa(clnt_addr.sin_addr),
			clnt_addr.sin_port);

		pid = fork();
		if (pid == -1) {
			(void) fprintf(stderr,
				"%i server_socket_tcp:18:%i "
				"fork !!! FAIL !!! %s\n",
				getpid(), my_pid, strerror(errno));
			close(s);
			return (1);
		}
		if (pid == 0) {		
			close(s);
			if_printf(p_print_S,
				"server_socket_tcp:19: child try recv\n");
			
			if (recv(ns, buf, sizeof (buf), 0) < 0) {
				(void) fprintf(stderr,
					"%i server_socket_tcp:20:"
					" recv  < 0: %s errno: %i\n",
					getpid(),
					strerror(errno), errno);
				break;
			}
			if_printf(p_print_S,
				"server_socket_tcp:21: recv(%s)\n", buf);
			buf[0] = 0;
			sprintf(buf,
				"4: from server %s to: host %s port %i",
				p_users_cnf->pw_name,
				inet_ntoa(clnt_addr.sin_addr),
				clnt_addr.sin_port);
			if_printf(p_print_S,
				"server_socket_tcp:22:"
				"try send(%s)\n", buf);
			if (send(ns, buf, sizeof (buf), 0) < 0) {
				(void) fprintf(stderr,
					"%i server_socket_tcp:23: "
					"send < 0: %s errno: %i\n",
					strerror(errno), errno);
				break;
			}
			if_printf(p_print_S,
				"server_socket_tcp:24:"
				" send(%s)\n", buf);
			close(ns);
			if_printf(p_print_p,
 				"server_socket_tcp:25: exit(0)\n");
			exit(0);
		}
		if_printf(p_print_p,
 			"server_socket_tcp:26: "
 			"created child %i for recv checking\n", pid);
		close(ns);
	}
	if_printf(p_print_S, "server_socket_tcp:27:%i: "
		"server end !!! OK !!!\n", my_pid);
	close(s);
	return (0);
}

int
server_cpecial()
{
int	s;
int	ns;
int	pid;
int	pidwait;
int	status;
int	nport;
int	i;
int	l;
int	ret;
int	res;
int	rez_listen;
int	rez_bind;
int	my_pid;
int	addrlen;
struct	sockaddr_in	serv_addr;
struct	sockaddr_in	clnt_addr;
struct	hostent	*hp;
char	buf[80];
char	buf_send[80];
char	path_file_serv[256];

	my_pid = getpid();
	
	nport = htons(CPEC_PORT);
	
	if_printf(p_print_SPEC,
		"server_cpecial:1: begin. htons(%i): %i\n", CPEC_PORT, nport);

	s = socket(AF_INET, SOCK_STREAM, 0);
	if (s == -1) {
		(void) fprintf(stderr,
			"%i server_cpecial:2: socket !!! FAIL !!! %s\n",
			getpid(), strerror(errno));
		return (1);
	}
	if_printf(p_print_SPEC, "server_cpecial:3: socket: %i\n", s);
	res = 1;
	if (setsockopt(s, SOL_SOCKET, SO_REUSEADDR, (char *)&res, 4) == -1) {
		(void) fprintf(stderr,
			"%i server_cpecial:2.1: "
			"setsockopt == -1: %s errno %i\n",
			getpid(), strerror(errno), errno);
		close(s);
		return (1);
	}

	bzero(&serv_addr, sizeof (serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = INADDR_ANY;
	serv_addr.sin_port = nport;

	errno = 0;
	if_printf(p_print_SPEC, "server_cpecial:4: try bind:\n"
		"\tserv_addr.sin_addr.s_addr %s\n"
		"\tserv_addr.sin_port %i\n",
		inet_ntoa(serv_addr.sin_addr),
		serv_addr.sin_port);
		
	rez_bind = bind(s, (struct sockaddr *)&serv_addr, sizeof (serv_addr));
	if (rez_bind == -1) {
		(void) fprintf(stderr,
			"%i: server_cpecial:5:tmac %i: bind !!! FAIL !!! %s\n",
			 getpid(), i_am_main, strerror(errno));
		close(s);
		return (1);
	}
	if_printf(p_print_SPEC, "server_cpecial:6: bind: %i\n", rez_bind);

	errno = 0;
	rez_listen = listen(s, 5);
	if (rez_listen == -1) {
		(void) fprintf(stderr,
			"%i: server_cpecial:7: listen !!! FAIL !!! %s\n",
			 getpid(), strerror(errno));
		close(s);
		return (1);
	}
	if_printf(p_print_SPEC, "server_cpecial:8: listen: %i\n", rez_listen);

	addrlen = sizeof (clnt_addr);
	bzero(&clnt_addr, addrlen);

	if_printf(p_print_SPEC, "server_cpecial:9: try accept()\n");
		
	ns = accept(s, (struct sockaddr *)&clnt_addr, &addrlen);
	if (ns == -1) {
		(void) fprintf(stderr,
			"%i: server_cpecial:10: accept !!! FAIL !!! %s\n",
			getpid(), strerror(errno));
		close(s);
		return (1);
	}
	if_printf(p_print_SPEC,
		"server_cpecial:11: accept: %i\n"
		"\tclnt_addr.sin_addr.s_addr %s\n"
		"\tclnt_addr.sin_port %i\n", ns,
		inet_ntoa(clnt_addr.sin_addr),
		clnt_addr.sin_port);

	if ((pid = fork()) == -1) {
		(void) fprintf(stderr,
			"%i: server_cpecial:12: fork() == -1 %s\n",
			getpid(), strerror(errno));
		close(s);
		return (1);
	}
	if (pid == 0) {
		int nbytes;
		int fout;
	
		if_printf(p_print_SPEC, "server_cpecial:13: try recv\n");
		close(s);
		if (recv(ns, buf, sizeof (buf), 0) < 0) {
			(void) fprintf(stderr,
				"%i: server_cpecial:14: recv < 0: %s\n",
				getpid(), strerror(errno));
			close(ns);
			exit(1);
		}
		if_printf(p_print_SPEC, "%server_cpecial:15: recv(%s)\n", buf);
		buf[0] = 0;
		sprintf(buf,
			"5: from: %s uid: %i to host: %s port: %i",
			HOST, getuid(),
			inet_ntoa(clnt_addr.sin_addr),
			clnt_addr.sin_port);
		if_printf(p_print_SPEC,
			"server_cpecial:16: try send(%s)\n", buf);
		if (send(ns, buf, sizeof (buf), 0) < 0) {
			(void) fprintf(stderr,
				"%i: server_cpecial:17:  send < 0 %s\n",
				getpid(), strerror(errno));
			close(ns);
			exit(1);
		}
		if_printf(p_print_SPEC,
			"server_cpecial:18: send(%s)\n", buf);
		close(ns);
		if_printf(p_print_SPEC,
 			"server_cpecial:19: exit(0)\n");
		exit(0);
	}
	if_printf(p_print_SPEC,
 		"server_cpecial:21: created child %i\n", pid);
 		
eee:	pidwait = waitpid(pid, &status, 0);

 	if (pidwait < 0) {
		(void) fprintf(stderr,
			"%i: TMAC: server_cpecial:22: waitpid < 0 "
			"errno %d (%s)\n",
			getpid(), errno, strerror(errno));
		if (errno == 4)
			goto eee;
	}
	if (WIFEXITED(status))	
		if_printf(p_print_SPEC,
 			"server_cpecial:23: "
 			"parent %i waited child %i "
 			"WEXITSTATUS(status): %i\n",
 			getpid(), pidwait, WEXITSTATUS(status));
	if (WIFSIGNALED(status))	
		if_printf(p_print_SPEC,
 			"server_cpecial:24: "
 			"parent %i waited child %i "
 			"WTERMSIG(status): %i\n",
 			getpid(), pidwait, WTERMSIG(status));
	if (WIFSTOPPED(status))	
		if_printf(p_print_SPEC,
 			"server_cpecial:25: "
 			"parent %i waited child %i "
 			"WSTOPSIG(status): %i\n",
 			getpid(), pidwait, WSTOPSIG(status));
	if_printf(p_print_SPEC, "server_cpecial:26:%i: "
		"server end !!! OK !!!\n", my_pid);
	close(s);
	return (0);
}
int
server_cpecial_2()
{
int	s;
int	ns;
int	pid;
int	pidwait;
int	status;
int	nport;
int	i;
int	l;
int	ret;
int	res;
int	rez_listen;
int	rez_bind;
int	my_pid;
int	addrlen;
struct	sockaddr_in	serv_addr;
struct	sockaddr_in	clnt_addr;
struct	hostent	*hp;
char	buf[80];
char	buf_send[80];
char	path_file_serv[256];

	my_pid = getpid();
	
	nport = htons(CPEC_PORT);
	
	if_printf(p_print_S,
		"server_cpecial_2:1: begin port %i\n", CPEC_PORT);

	s = socket(AF_INET, SOCK_STREAM, 0);
	if (s == -1) {
		(void) fprintf(stderr,
			"%i: server_cpecial_2:2: socket !!! FAIL !!! %s\n",
			getpid(), strerror(errno));
		return (1);
	}
	if_printf(p_print_S, "server_cpecial_2:3: socket: %i\n", s);

	res = 1;
	res = setsockopt(s, SOL_SOCKET, SO_REUSEADDR, (char *)&res, 4);
	if (res == -1) {
		(void) fprintf(stderr,
			"%i server_cpecial_2:3.1: "
			"setsockopt == -1 !!! %s errno %i\n",
			getpid(), errno,
			strerror(errno));
	}
	bzero(&serv_addr, sizeof (serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = INADDR_ANY;
	serv_addr.sin_port = nport;

	errno = 0;
	if_printf(p_print_S, "server_cpecial_2:4: try bind:\n"
		"\tserv_addr.sin_addr.s_addr %s\n"
		"\tserv_addr.sin_port %i\n",
		inet_ntoa(serv_addr.sin_addr),
		serv_addr.sin_port);
		
	rez_bind = bind(s, (struct sockaddr *)&serv_addr, sizeof (serv_addr));
	if (rez_bind == -1) {
		(void) fprintf(stderr,
			"%i: server_cpecial_2:5: bind !!! FAIL !!! %s\n",
			 getpid(), strerror(errno));
		return (1);
	}
	if_printf(p_print_S, "server_cpecial_2:6: bind: %i\n", rez_bind);

	errno = 0;
	rez_listen = listen(s, 5);
	if (rez_listen == -1) {
		(void) fprintf(stderr,
			"%i: server_cpecial_2:7: listen !!! FAIL !!! %s\n",
			 getpid(), strerror(errno));
		return (1);
	}
	if_printf(p_print_S, "server_cpecial_2:8: listen: %i\n", rez_listen);

	addrlen = sizeof (clnt_addr);
	bzero(&clnt_addr, addrlen);
	if_printf(p_print_S,
		"server_cpecial_2:9: try accept()\n");	
	ns = accept(s, (struct sockaddr *)&clnt_addr, &addrlen);
	if (ns == -1) {
		(void) fprintf(stderr,
			"%i: server_cpecial_2:10: "
			"accept !!! FAIL !!! %s\n",
			getpid(), strerror(errno));
		return (1);
	}
	if_printf(p_print_S,
		"server_cpecial_2:11: accept: %i\n"
		"\tclnt_addr.sin_addr.s_addr %s\n"
		"\tclnt_addr.sin_port %i\n",
		ns,
		inet_ntoa(clnt_addr.sin_addr),
		clnt_addr.sin_port);
	pid = fork();
	if (pid == -1) {
		(void) fprintf(stderr,
			"%i: server_cpecial_2:12: "
			"fork !!! FAIL !!! %s\n",
			getpid(), strerror(errno));
		return (1);
	}
	if (pid == 0) {		
		if_printf(p_print_S,
			"server_cpecial_2:13: child: %i\n",
			getpid());
		close(s);
		errno = 0;
		if (recv(ns, buf, sizeof (buf), 0) < 0) {
			(void) fprintf(stderr,
				"%i: server_cpecial_2:14:"
				" recv < 0: %s\n",
				getpid(), strerror(errno));
			exit(1);
		}
		if_printf(p_print_p,
			"server_cpecial_2:15: recv(%s)\n", buf);
		errno = 0;
		buf[0] = 0;
		sprintf(buf,
			"6: from: %s uid: %i to host: %s port: %i",
			HOST_LOCK, getuid(),
			inet_ntoa(clnt_addr.sin_addr),
			clnt_addr.sin_port);
		if_printf(p_print_p,
			"server_cpecial_2:16: try send(%s)\n", buf);
		if (send(ns, buf, sizeof (buf), 0) < 0) {
			(void) fprintf(stderr,
				"%i: server_cpecial_2:17: "
				"send < 0 %s\n",
				getpid(), strerror(errno));
			exit(1);
		}
		if_printf(p_print_p,
			"server_cpecial_2:18: send(%s)\n", buf);
		close(ns);
		if_printf(p_print_p,
 			"server_cpecial_2:19: "
 			"exit(0) pid %i\n",
 			getpid());
		exit(0);
	}
	if_printf(p_print_p,
 		"server_cpecial_2:20: "
 		"parent %i created child %i "
 		"for wait sig of creat serv\n",
 		getpid(), pid);
 			
eee:	pidwait = waitpid(pid, &status, 0);

 	if (pidwait < 0) {
		(void) fprintf(stderr,
			"%i: TMAC: server_cpecial_2:21: "
			"waitpid(%i) < 0  "
			"errno %d (%s)\n",
			getpid(), pid,
			errno, strerror(errno));
			if (errno == 4)
				goto eee;
	}
	if (WIFEXITED(status))	
		if_printf(p_print_p,
 			"server_cpecial_2:22: "
 			"parent %i waited child %i "
 			"WEXITSTATUS(status): %i\n",
 			getpid(), pidwait, WEXITSTATUS(status));
	if (WIFSIGNALED(status))	
		if_printf(p_print_p,
 			"server_cpecial_2:23: "
 			"parent %i waited child %i "
 			"WTERMSIG(status): %i\n",
 			getpid(), pidwait, WTERMSIG(status));
	if (WIFSTOPPED(status))	
		if_printf(p_print_p,
 			"server_cpecial_2:24: "
 			"parent %i waited child %i "
 			"WSTOPSIG(status): %i\n",
 			getpid(), pidwait, WSTOPSIG(status));
	close(ns);
	if_printf(p_print_S, "server_cpecial_2:25:%i: "
		"server end !!! OK !!!\n", my_pid);
	return (0);
}
*/
char *
obtainlex(char *p)
{
	char	c;
	char	*r;
//	char	*i;
//	int	p_prob_was = 0;
	int	p_lex_was = 0;
	
	if (p == NULL) {
		(void) fprintf(stderr,
			"%i: obtainlex:: p == NULL\n", getpid());
		return ((char *)0);
	}
	r = NULL;
	while ((c = *p++) != '\0')
	switch (c) {
	case ' ':
	case '\t':
		*(p - 1) = 0;
		if (p_lex_was)
			return (r);
		// p_prob_was = 1;
		break;
	case ':':
	case '=':
	case '\n':
		*(p - 1) = 0;
		return (r);
	default:
		if (p_lex_was == 0)
			r = p - 1;
		p_lex_was = 1;
	}
	return (r);
}

int
arrow_digit(char *p)
{
	char	c;
	
	if (p == NULL) {
		(void) fprintf(stderr,
			"%i arrow_digit:: p == NULL\n", getpid());
		return (1);
	}
	while ((c = *p++) != '\0')
	switch (c) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
		break;
	default:
		return (1);
	}
	return (0);
}

int
get_nport(char *pf)
{
	
	if (pf == NULL) {
		(void) fprintf(stderr,
			"%i: get_nport:: pf == NULL\n", getpid());
		return (1);
	}
	
	if ((pf = obtainlex(pf)) == NULL) {
		(void) fprintf(stderr,
			"%i: get_nport::could't found lex\n", getpid());
		return (1);
	}
	if (arrow_digit(pf)) {
		(void) fprintf(stderr,
			"%i: get_nport:: lex is not digit: %s\n",
			getpid(), pf);
		return (1);
	}
	return (atoi(pf));
}

int
inic_host()
{

//	char	com[STRSIZE];
//	int	ret;
//	int	pid;
//	int	pidwait;
	
	if_printf(p_print_Sh, "inic_host:1: begin\n");
/*	
 	com[0] = 0;
	sprintf(com, "rsh %s '(export ROOT_E90=%s; %s 0)'",
		HOST, p_ROOT_E90, TMAC_EXE);
	pid_rcp_rsh =  fork();
  	switch (pid_rcp_rsh) {
	case 0:	
		if_printf(p_print_Sh, "inic_host:6: try system(%s)\n", com);
		if ((ret = system(com)) != 0) {
		(void) fprintf(stderr,
			"%i TMAC fail:3: could't system(%s)\n",
			 getpid(), com);
		exit(1);
		}
		if_printf(p_print_Sh, "inic_host:7: ret: %i\n", ret);
		exit(0);
	case -1:
		(void) fprintf(stderr,
			"%i TMAC:fail:inic_host:8: fork(): %s\n",
			getpid(), strerror(errno));
		return (1);
	default:
		if_printf(p_print_p,
 			"inic_host:9: parent %i "
 			"created child %i for %s\n",
 			getpid(), pid_rcp_rsh, com);
		if (server_cpecial_2() != 0) {
			(void) fprintf(stderr,
				"%i TMAC: inic_host:10: "
				"server_cpecial_2() != 0\n", getpid());
			return (1);
		}
	}
*/
	return (0);
}

void
delete_obj(passwd_users_t **p_users_cnf)
{
//	int	s;
//	int	rez_send;
//	int	rez_bind;
//	int	rez_connect;
//	int	pidwait;
//	int	status;
//	struct	sockaddr_in	clnt_addr;
//	struct	hostent	*hp;
//	char	buf[80];
	
	if ((delete_msg(p_users_cnf)) != 0) {
		(void) fprintf(stderr,
			"%i: TMAC: delete_msg != 0\n", getpid());
	}

//	if ((delete_sem(p_users_cnf)) != 0) {
//		(void) fprintf(stderr,
//			"%i: TMAC: delete_sem != 0\n", getpid());
//	}

//	if ((delete_server(p_users_cnf)) != 0) {
//		(void) fprintf(stderr,
//			"%i: TMAC: delete_server != 0\n", getpid());
//	}

	if ((delete_shm(p_users_cnf)) != 0) {
		(void) fprintf(stderr,
			"%i: TMAC: delete_shm != 0\n", getpid());
	}
	
/*
 *	Формирование ответа удаленной машине об окончании проверок.
 */
/*
	hp = gethostbyname(HOST);
	
	if (hp == 0) {
		(void) fprintf(stderr,
			"%i: delete_obj:: gethostbyname !!! FAIL !!! %s\n",
			getpid(), strerror(errno));
		return (1);
	}
	bzero(&clnt_addr, sizeof (clnt_addr));
	bcopy(hp->h_addr, &clnt_addr.sin_addr, hp->h_length);
	clnt_addr.sin_family = hp->h_addrtype;
	clnt_addr.sin_port = htons(CPEC_PORT);
	if_printf(p_print_S,
		"delete_obj:1: gethostbyname:\n"
		"clnt_addr.sin_addr %s\n"
		"clnt_addr.sin_port %i\n",
		inet_ntoa(clnt_addr.sin_addr),
		clnt_addr.sin_port);

	errno = 0;
	s = socket(AF_INET, SOCK_STREAM, 0);
	if (s == -1) {
		(void) fprintf(stderr,
			"%i delete_obj:: socket !!! FAIL !!! %s\n",
			getpid(), strerror(errno));
		return (1);
	}
	rez_connect = connect(s, (struct sockaddr *)&clnt_addr,
				sizeof (clnt_addr));
	if (rez_connect < 0) {
		(void) fprintf(stderr,
			"%i delete_obj:3: connect FAIL !!! %s\n",
			getpid(), strerror(errno));
		return (1);
	}
	if_printf(p_print_S, "delete_obj:3: connect: %i\n",
		rez_connect);
	errno = 0;
	buf[0] = 0;
	sprintf(buf,
		"7: from: %s uid: %i to host: %s port: %i",
		HOST_LOCK, getuid(),
		inet_ntoa(clnt_addr.sin_addr),
		clnt_addr.sin_port);
		
	if_printf(p_print_p, "delete_obj:4: try send(%s)\n", buf);
	
	rez_send = send(s, buf, sizeof (buf), 0);
	if (rez_send == -1) {
		(void) fprintf(stderr,
			"%i delete_obj:5: send == -1 "
			"!!! FAIL !! %s\n",
			 getpid(), strerror(errno));
		return (1);
	}
			
	if_printf(p_print_p,
		"delete_obj:6: send(%s)\n", buf);
				
	if (recv(s, buf, sizeof (buf), 0) < 0) {
		(void) fprintf(stderr,
			"%i delete_obj:6: recv "
			"!!! FAIL !!! %s\n",
			 getpid(), strerror(errno));
		return (1);
	}
			
	if_printf(p_print_p,
		"delete_obj:6: recv(%s)\n", buf);
		
	close(s);
	if_printf(p_print_p,
		"delete_obj:7: try waitpid(pid_rcp_rsh: %i)\n", pid_rcp_rsh);
	pidwait = waitpid(pid_rcp_rsh, &status, 0);
	if_printf(p_print_p,
		"delete_obj:7.1: waitpid(pid_rcp_rsh: %i) = %i\n",
		pid_rcp_rsh, pidwait);
	sleep(2);
	return (0);
*/
}

int send_msg(passwd_users_t **p_users_cnf)
{
	int	i = 0;
	int	i_msg;
	int	p_msg;
	struct	msqid_ds	msg_stat;
	
	while (p_users_cnf[i]) {
		i_msg = (p_users_cnf[i])->pw_uid + 1;
		if ((p_msg = msgget(i_msg, 0)) < 0) {
			(void) fprintf(stderr,
				"%i send_msg: "
				"%s: msgget(%i, 0): "
				"%s errno: %i\n",
				getpid(),
				(p_users_cnf[i])->pw_name,
				p_msg, strerror(errno), errno);
		i++;
			continue;
		}
		if ((msgctl(p_msg, IPC_STAT, &msg_stat)) < 0) {
			(void) fprintf(stderr,
				"%i send_msg: "
				"%s: msgctl(%i, IPC_STAT): "
				"%s errno: %i\n",
				getpid(),
				(p_users_cnf[i])->pw_name,
				p_msg, strerror(errno), errno);
		i++;
			continue;
		}
		if (msg_stat.msg_qnum == 0) {
			if ((ret = msgsnd(p_msg, &msg_snd,
				strlen(msg_snd.mtext) + 1, IPC_NOWAIT)) < 0) {
				(void) fprintf(stderr,
					"%i send_msg: "
					"%s: msgsnd(%i, %i): "
					"%s errno: %i\n",
					getpid(),
					(p_users_cnf[i])->pw_name,
					p_msg, i, strerror(errno), errno);
		i++;
				continue;
			}
		}
		i++;
	}
	return (0);
}

int main(int argc, char ** argv)
{
	struct timeval start_time;
	struct timeval current_time;
	struct timeval delta_time;

	gettimeofday(&start_time, 0);
	euid_old = geteuid();
	egid_old = getegid();
	uid_old = getuid();
	gid_old = getgid();
		
	if ((euid_old != 0) || (uid_old != 0)) {
		(void) fprintf(stderr,
			"TMAC: You must be root !!! \n");
		return (1);
	}
	
	if (argc != 2) {
		(void) fprintf(stderr,
			"TMAC: Используйте: %s <1 | h> \n", argv[0]);
		(void) fprintf(stderr,
			"                              где:\n"
			"1 - формирование матрицы доступа "
			"для пользователей, указанных в файле tmac.cnf,\n"
			"\n"
			"h - пояснения к изображению матрицы доступа.\n"
			);
		return (1);
	}
	
	if (*(argv[1]) == '1')
		i_am_main = 1;
	else
	if (*(argv[1]) == '0')
		i_am_main = 0;
	else
	if (*(argv[1]) == 'h') {
		(void) fprintf(stderr,
			"%s\n", p_comment);
		return (0);
	}
	else {
		(void) fprintf(stderr,
			"TMAC: Используйте: %s <1 | h> \n", argv[0]);
		(void) fprintf(stderr,
			"                              где:\n"
			"1 - формирование матрицы доступа "
			"для пользователей, указанных в файле tmac.cnf,\n"
			"\n"
			"h - пояснения к изображению матрицы доступа.\n"
			);
		return (1);
	}
	
	if ((p_users_cnf = get_users_cnf()) == NULL) {
		(void) fprintf(stderr,
			"TMAC: get_users_cnf == NULL\n");
		return (1);
	}
	
	gettimeofday(&current_time, 0);
	delta_usec(&start_time, &current_time, &delta_time);
	if_printf(p_print_usag, "time get_users_cnf %ld %ld ms\n"
		, delta_time.tv_sec, delta_time.tv_usec
	);

	if ((creat_obj(p_users_cnf)) != 0) {
		(void) fprintf(stderr,
			"TMAC: creat_obj != 0\n");
		return (1);
	}

	gettimeofday(&current_time, 0);
	delta_usec(&start_time, &current_time, &delta_time);
	if_printf(p_print_usag, "time creat_obj %lld ms\n"
		, delta_time.tv_sec, delta_time.tv_usec
	);

	if ((check_access_users(p_users_cnf)) != 0) {
		(void) fprintf(stderr,
			"TMAC: check_access_users != 0\n");
		return (1);
	}
	if_printf(p_print_usag, p_comment);
	gettimeofday(&current_time, 0);
	delta_usec(&start_time, &current_time, &delta_time);
	if_printf(p_print_usag, "time check_access_users %lld ms\n"
		, delta_time.tv_sec, delta_time.tv_usec
	);

	if (i_am_main) {
		delete_obj(p_users_cnf);
	}
	gettimeofday(&current_time, 0);
	delta_usec(&start_time, &current_time, &delta_time);
	if_printf(p_print_usag, "time delete msg sem server %lld ms\n"
		, delta_time.tv_sec, delta_time.tv_usec
	);

	return (0);
}

